#############################################################################
# E.S.O. - VLT project
#
# "@(#) $Id: Hawaii.v,v 1.104 2005/09/12 09:20:34 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# jstegmei  08/10/98  created
#
#############################################################################
#
# DESCRIPTION
# Voltage file for Rockwell 1024x1024 array (Hawaii).
#
#############################################################################

#############################################################################
# Space for additional information...
#############################################################################

#############################################################################
# Clock Voltages:
#############################################################################
DET.VOLT.CLKHINM1 "clk1Hi PIXEL2-3";      # Name of High Clock
DET.VOLT.CLKHI1     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA1 "[4.500, 5.500]";       # Allowed range for High Clock
DET.VOLT.CLKHIDAC1          1;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL1          1;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM1 "clk1Lo PIXEL2-3";      # Name of Low Clock
DET.VOLT.CLKLO1     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA1 "[-0.500, 0.500]";      # Allowed range for Low Clock
DET.VOLT.CLKLODAC1          2;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL1          2;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM2  "clk2Hi PIXEL1-4";     # Name of High Clock
DET.VOLT.CLKHI2     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA2  "[4.500, 5.500]";      # Allowed range for High Clock
DET.VOLT.CLKHIDAC2          3;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL2          3;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM2  "clk2Lo PIXEL1-4";     # Name of Low Clock
DET.VOLT.CLKLO2     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA2  "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC2          4;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL2          4;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM3  "clk3Hi LSYNC1-2-3-4"; # Name of High Clock
DET.VOLT.CLKHI3     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA3  "[4.500, 5.500]";      # Allowed range for High Clock
DET.VOLT.CLKHIDAC3          5;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL3          5;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM3  "clk3Lo LSYNC1-2-3-4"; # Name of Low Clock
DET.VOLT.CLKLO3     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA3  "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC3          6;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL3          6;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM4  "clk4Hi LINE1-2";      # Name of High Clock
DET.VOLT.CLKHI4     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA4  "[4.500, 5.500]";      # Allowed range for High Clock
DET.VOLT.CLKHIDAC4          7;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL4          7;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM4  "clk4Lo LINE1-2";      # Name of Low Clock
DET.VOLT.CLKLO4     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA4  "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC4          8;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL4          8;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM5  "clk5Hi LINE3-4";      # Name of High Clock
DET.VOLT.CLKHI5     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA5  "[4.500, 5.500]";      # Allowed range for High Clock
DET.VOLT.CLKHIDAC5          9;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL5          9;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM5  "clk5Lo LINE3-4";      # Name of Low Clock
DET.VOLT.CLKLO5     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA5  "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC5         10;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL5         10;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM6  "clk6Hi FSYNC1-2-3-4"; # Name of High Clock
DET.VOLT.CLKHI6     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA6  "[4.500, 5.500]";      # Allowed range for High Clock
DET.VOLT.CLKHIDAC6         11;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL6         11;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM6  "clk6Lo FSYNC1-2-3-4"; # Name of Low Clock
DET.VOLT.CLKLO6     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA6  "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC6         12;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL6         12;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM7  "clk7Hi READ1-2-3-4";  # Name of High Clock
DET.VOLT.CLKHI7     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA7  "[-0.500, 5.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC7         13;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL7         13;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM7  "clk7Lo READ1-2-3-4";  # Name of Low Clock
DET.VOLT.CLKLO7     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA7  "[-0.500, 5.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC7         14;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL7         14;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM8  "clk8Hi RESET1-2-3-4"; # Name of High Clock
DET.VOLT.CLKHI8     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA8  "[-0.500, 5.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC8         15;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL8         15;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM8  "clk8Lo RESET1-2-3-4"; # Name of Low Clock
DET.VOLT.CLKLO8     0.000;                # Set value for Low Clock
DET.VOLT.CLKLORA8  "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC8         16;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL8         16;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM9  "clk9Hi VDD1-2-3-4";   # Name of High Clock
DET.VOLT.CLKHI9     5.000;                # Set value for High Clock
DET.VOLT.CLKHIRA9  "[-0.500, 5.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC9         17;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL9         17;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM9  "clk9Lo VDD1-2-3-4";   # Name of Low Clock
DET.VOLT.CLKLO9     5.000;                # Set value for Low Clock
DET.VOLT.CLKLORA9  "[-0.500, 5.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC9         18;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL9         18;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM10 "clk10Hi ";            # Name of High Clock
DET.VOLT.CLKHI10     5.000;               # Set value for High Clock
DET.VOLT.CLKHIRA10 "[4.000, 6.000]";      # Allowed range for High Clock
DET.VOLT.CLKHIDAC10        19;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL10        19;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM10 "clk10Lo ";            # Name of Low Clock
DET.VOLT.CLKLO10     5.000;               # Set value for Low Clock
DET.VOLT.CLKLORA10 "[4.000, 6.000]";      # Allowed range for Low Clock
DET.VOLT.CLKLODAC10        20;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL10        20;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM11 "clk11Hi ";            # Name of High Clock
DET.VOLT.CLKHI11     0.000;               # Set value for High Clock
DET.VOLT.CLKHIRA11 "[-0.500, 0.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC11        21;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL11        21;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM11 "clk11Lo ";            # Name of Low Clock
DET.VOLT.CLKLO11     0.000;               # Set value for Low Clock
DET.VOLT.CLKLORA11 "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC11        22;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL11        22;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM12 "clock12Hi";           # Name of High Clock
DET.VOLT.CLKHI12     0.000;               # Set value for High Clock
DET.VOLT.CLKHIRA12 "[-0.500, 0.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC12        23;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL12        23;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM12 "clock12Lo";           # Name of Low Clock
DET.VOLT.CLKLO12     0.000;               # Set value for Low Clock
DET.VOLT.CLKLORA12 "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC12        24;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL12        24;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM13 "clock13Hi";           # Name of High Clock
DET.VOLT.CLKHI13     5.000;               # Set value for High Clock
DET.VOLT.CLKHIRA13 "[-0.500, 5.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC13        25;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL13        25;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM13 "clock13Lo";           # Name of Low Clock
DET.VOLT.CLKLO13     0.000;               # Set value for Low Clock
DET.VOLT.CLKLORA13 "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC13        26;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL13        26;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM14 "clock14Hi";           # Name of High Clock
DET.VOLT.CLKHI14     0.000;               # Set value for High Clock
DET.VOLT.CLKHIRA14 "[-0.500, 0.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC14        27;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL14        27;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM14 "clock14Lo";           # Name of Low Clock
DET.VOLT.CLKLO14     0.000;               # Set value for Low Clock
DET.VOLT.CLKLORA14 "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC14        28;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL14        28;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM15 "clock15Hi";           # Name of High Clock
DET.VOLT.CLKHI15     0.000;               # Set value for High Clock
DET.VOLT.CLKHIRA15 "[-0.500, 0.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC15        29;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL15        29;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM15 "clock15Lo";           # Name of Low Clock
DET.VOLT.CLKLO15     0.000;               # Set value for Low Clock
DET.VOLT.CLKLORA15 "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC15        30;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL15        30;            # TEL Ch. for Low Clock

DET.VOLT.CLKHINM16 "clock16Hi";           # Name of High Clock
DET.VOLT.CLKHI16     0.000;               # Set value for High Clock
DET.VOLT.CLKHIRA16 "[-0.500, 0.500]";     # Allowed range for High Clock
DET.VOLT.CLKHIDAC16        31;            # DAC Ch. for High Clock 
DET.VOLT.CLKHITEL16        31;            # TEL Ch. for High Clock

DET.VOLT.CLKLONM16 "clock16Lo";           # Name of Low Clock
DET.VOLT.CLKLO16     0.000;               # Set value for Low Clock
DET.VOLT.CLKLORA16 "[-0.500, 0.500]";     # Allowed range for Low Clock
DET.VOLT.CLKLODAC16        32;            # DAC Ch. for Low Clock 
DET.VOLT.CLKLOTEL16        32;            # TEL Ch. for Low Clock

#############################################################################
# DC Voltages:
#############################################################################
DET.VOLT.DCNM1   "DC1  VRESET1-2-3-4";    # Name for DC Voltage
DET.VOLT.DC1     4.800;                   # Set value for DC Voltage
DET.VOLT.DCRA1   "[0.000, 6.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC1            33;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL1            33;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM2   "DC2  DSUB";             # Name for DC Voltage
DET.VOLT.DC2     0.000;                   # Set value for DC Voltage
DET.VOLT.DCRA2   "[-6.000, 0.000]";       # Allowed range for DC Voltage
DET.VOLT.DCDAC2            34;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL2            34;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM3   "DC3  CELLWELL";         # Name for DC Voltage
DET.VOLT.DC3     5.000;                   # Set value for DC Voltage
DET.VOLT.DCRA3   "[4.000, 7.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC3            35;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL3            35;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM4   "DC4  VBUS";             # Name for DC Voltage
DET.VOLT.DC4     5.000;                   # Set value for DC Voltage
DET.VOLT.DCRA4   "[3.000, 7.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC4            36;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL4            36;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM5   "DC5  HIGH1";            # Name for DC Voltage
DET.VOLT.DC5     5.000;                   # Set value for DC Voltage
DET.VOLT.DCRA5   "[4.000, 6.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC5            37;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL5            37;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM6   "DC6  HIGH2";            # Name for DC Voltage
DET.VOLT.DC6     5.000;                   # Set value for DC Voltage
DET.VOLT.DCRA6   "[4.000, 6.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC6            38;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL6            38;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM7   "DC7  HIGH3";            # Name for DC Voltage
DET.VOLT.DC7     5.000;                   # Set value for DC Voltage
DET.VOLT.DCRA7   "[4.000, 6.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC7            39;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL7            39;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM8   "DC8  HIGH4";            # Name for DC Voltage
DET.VOLT.DC8     5.000;                   # Set value for DC Voltage
DET.VOLT.DCRA8   "[4.000, 6.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC8            40;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL8            40;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM9   "DC9  VDD1-2-3-4";       # Name for DC Voltage
DET.VOLT.DC9     5.000;                   # Set value for DC Voltage
DET.VOLT.DCRA9   "[4.500, 5.500]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC9            41;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL9            49;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM10  "DC10  REF1 (-2-3-4)";   # Name for DC Voltage
DET.VOLT.DC10     2.600;                  # Set value for DC Voltage
DET.VOLT.DCRA10  "[0.000, 5.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC10           42;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL10           50;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM11  "DC11  REF2";            # Name for DC Voltage
DET.VOLT.DC11     2.423;                  # Set value for DC Voltage
DET.VOLT.DCRA11  "[0.000, 5.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC11           43;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL11           51;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM12  "DC12  REF3";            # Name for DC Voltage
DET.VOLT.DC12     2.436;                  # Set value for DC Voltage
DET.VOLT.DCRA12  "[0.000, 5.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC12           44;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL12           52;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM13  "DC13  REF4";            # Name for DC Voltage
DET.VOLT.DC13     2.436;                  # Set value for DC Voltage
DET.VOLT.DCRA13  "[0.000, 5.000]";        # Allowed range for DC Voltage
DET.VOLT.DCDAC13           45;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL13           53;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM14  "DC14";                  # Name for DC Voltage
DET.VOLT.DC14     0.000;                  # Set value for DC Voltage
DET.VOLT.DCRA14  "[-0.500, 0.500]";       # Allowed range for DC Voltage
DET.VOLT.DCDAC14           46;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL14           54;            # TEL Ch. for DC Voltage

DET.VOLT.DCNM15  "DC15";                  # Name for DC Voltage
DET.VOLT.DC15     0.000;                  # Set value for DC Voltage
DET.VOLT.DCRA15  "[-0.500, 0.500]";       # Allowed range for DC Voltage
DET.VOLT.DCDAC15           47;            # DAC Ch. for DC Voltage
DET.VOLT.DCTEL15           55;            # TEL Ch. for DC Voltage

#
# --- oOo ---
