#ifndef iracqIMG_H
#define iracqIMG_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: iracqIMG.h,v 1.113 2005/09/13 07:27:10 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jstegmei  05/05/00  created
*/

/************************************************************************
 *  iracqIMG.h - Image post-processing class
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#ifndef USE
#define USE(x) x=x
#endif

/*
 *  image class
 */
class iracqIMG
{
public:
  iracqIMG();          
  iracqIMG(int, int);          

  virtual ~iracqIMG(); 

  char      *ErrMsg();
  int        InitErr();
  int        Dim(int, int);
  int        Enable();
  int        Disable();
  int        Stat();
  int        NX();
  int        NY();

  int        Clear();
  int        Apply();
  void       Trans(void **, void **, int, int);
  void       Trans(void *, void *, int, int);
  void       Trans(void *, int, int);
  void       Trans16(void **, void **, int);
  void       Trans32(void **, void **, int);
  void       Trans64(void **, void **, int);
  void       Trans16(void *, void *, int);
  void       Trans32(void *, void *, int);
  void       Trans64(void *, void *, int);
  void       Trans16(void *, int);
  void       Trans32(void *, int);
  void       Trans64(void *, int);

  int        Rot(int);
  int        FlipX();
  int        FlipY();
protected:

private:
  int        Init_();
  void       FreeT_();
  void       Mul_(int, int, int, int);

  char       erms_[256];
  int        initErr_;

  int        status_;

  int        nx_;
  int        ny_;
  int        nx1_;
  int        ny1_;
  int        size_;
  int       *T_;
  int        t1_;
  int        t2_;
  int        t3_;
  int        t4_;
  int        valid_;
  int        opChanged_;
};

#endif /*!iracqIMG_H*/
