#ifndef oslxALIAS_H
#define oslxALIAS_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: oslxALIAS.h,v 1.253 2005/08/17 13:09:20 vltsccm Exp $" 
*
* oslxALIAS.h
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  22/09/95  Created
* jknudstr  01/10/95  Lots of changes ...
*/

/************************************************************************
*  Header file for the OSLX class oslxALIAS
*----------------------------------------------------------------------
*/


#ifndef __cplusplus
#error This is a C++ include file which cannot be used from plain C
#endif

#include "oslxPRIVATE.h"


// Structure to hold one aliad<->keyword relation   
typedef struct {
     char             shortFITS[64];
     char             alias[64];
} oslxALIAS_EL;


// Class to handle aliasing of setup keywords.
class oslxALIAS: public oslxBASE
{
  public:
    oslxALIAS(slxALIAS_TABLE  aliasTable = NULL);
    ~oslxALIAS();
    
    ccsCOMPL_STAT Clear();
    ccsCOMPL_STAT Load(const slxFILENAME aliasTableName,
		       const vltLOGICAL  merge = FALSE);  
    ccsCOMPL_STAT Unload();
    ccsCOMPL_STAT GetAlias(const slxKEYW_LINE keyword, 
			   slxALIAS           alias);
    ccsCOMPL_STAT _GetAlias(const slxKEYW_LINE   keyword, 
			    slxALIAS             alias,
			    ccsERROR             *error);
    ccsCOMPL_STAT GetKeyword(const slxALIAS  alias, 
			     slxKEYW_LINE    keyword);
    ccsCOMPL_STAT _GetKeyword(const slxALIAS  alias, 
			      slxKEYW_LINE    keyword,
			      ccsERROR        *error);
    vltLOGICAL    IsAlias(const slxKEYW_LINE  name,
			  slxKEYW_LINE        keyword = NULL);
    ccsCOMPL_STAT ResetRecordPtr();
    vltLOGICAL    GetNextRecord(slxKEYW_LINE   keyword,
				slxALIAS       alias);

  protected:
    slxALIAS_TABLE     aliasTableName;
    slxFILENAME        aliasTableFileName;
    miscHASH_TABLE     aliasHashTable;
    miscHASH_TABLE     keywHashTable;
    vltLOGICAL         aliasTableLoaded;
};   // end-class oslxALIAS 


#endif /*!oslxALIAS_H*/
