#ifndef oslxTSF_H
#define oslxTSF_H
/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: oslxTSF.h,v 1.253 2005/08/17 13:09:25 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  11/06/97  created
* - - - - - - - - - - APR2005 - - - - - - - - - - - - - - - - - - -
* mnylund   13/08/04  SPR VLTSW20040035 Cleanup of code
*                     LoadDictionary and SetDictionary are removed; 
*                     use methods implemented in parent class oslxSHORT_FITS
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef __cplusplus
#error This is a C++ include file and cannot be used from plain C
#endif

#include "oslxPRIVATE.h"
#include "oslxFITS_BASE.h"
#include "oslxSHORT_FITS.h"

#define  oslxTPL_UNDEFINE  "_tpl_undefine_"
#define  oslxTPL_SUPPRESS  "_tpl_suppress_"

class oslxTSF: public oslxSHORT_FITS
{
  public: 
    oslxTSF();
    ~oslxTSF();

    //VLTSW20040035
    // ccsCOMPL_STAT LoadDictionary(const slxDICTIONARY  dicName,
    //				 const vltLOGICAL     merge = FALSE);
    //ccsCOMPL_STAT SetDictionary(const oslxDICTIONARY *dictionary);

    ccsCOMPL_STAT ClearPri();

    ccsCOMPL_STAT LoadTsf(const slxFILENAME  fileName);

    ccsCOMPL_STAT Save(const char                *obsMode,
		       const vltLOGICAL          useChangeRecord = FALSE,
		       oslxKEYW_FILTER           *filter = NULL,
		       const vltLOGICAL          saveComments = FALSE,
		       const vltLOGICAL          saveIncludedKeys = FALSE);

    ccsCOMPL_STAT SaveAs(const slxFILENAME        fileName,
			 const char               *obsMode = NULL,
			 const vltLOGICAL         useChangeRecord = FALSE,
			 oslxKEYW_FILTER          *filter = NULL,
			 const vltLOGICAL         saveComments = FALSE,
			 const vltLOGICAL         saveIncludedKeys = FALSE);

  protected:

    ccsCOMPL_STAT CheckAddDicKeys(const slxKEYW_LINE  keyword);
    ccsCOMPL_STAT oslxTSF::SearchFile(const slxFILENAME    baseName,
				      vltINT32             *numberFound,
				      slxSTRING_LIST       *fileList,
				      const vltLOGICAL     globalSearch,
				      const vltLOGICAL     stopFirstOccur,
				      const vltLOGICAL     skipInsUserDir);
    ccsCOMPL_STAT _ArrangeKeys();
    slxKEYW_LINE  _parList[10];
};


#endif /*!oslxTSF_H*/
