/*******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: rmacDefines.h,v 1.26 2005/02/25 11:19:40 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* tphan     25/10/00  Split from rmac.h 
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */

#ifndef RMAC_DEFINES_H
#define RMAC_DEFINES_H

/************************************************************************
 * Contains the public global data and data type definitions 
 * to be used in accessing the Reflective Memory
 *----------------------------------------------------------------------
 */


/*
 ***************************************************************************
 * Header Files
 ***************************************************************************
 */
 
/*
 ***************************************************************************
 * Constants and Literals
 ***************************************************************************
 */
#define   rmacMAX_NUM_OF_DL  	8

/*
 * Reflexive Memory Board node Id
 */
/* OPD Controller and Monitor */
#define rmacOPD_BASE_NODE    0x00
#define rmacOPDC_NODE        0x00
#define rmacOPDM_NODE        0x01

/* Delay Lines 1 to 8 */
#define rmacDL_BASE_NODE     0x08
#define rmacDL1_NODE         0x08
#define rmacDL2_NODE         0x09
#define rmacDL3_NODE         0x0A
#define rmacDL4_NODE         0x0B
#define rmacDL5_NODE         0x0C
#define rmacDL6_NODE         0x0D
#define rmacDL7_NODE         0x0E
#define rmacDL8_NODE         0x0F

/* FSU */
#define rmacFSU_BASE_NODE    0x04
#define rmacFSU_NODE         0x04
#define rmacFINITO_NODE      0x04

/* PRIMA: Metrology and FSU A/B */
/* Node IDs taken from VLT-SPE-ESO-17100-3439 */
#define rmacPRIMA_BASE_NODE  0x11

#define rmacPRIFSUA_NODE     0x11 
#define rmacPRIFSUB_NODE     0x12
#define rmacPRIMET_NODE      0x13

/* MIDI */
#define rmacMIDI_BASE_NODE   0x30
#define rmacMILCU_NODE       0x30

/* VINCI */
#define rmacVINCI_BASE_NODE  0x40
#define rmacWVNDC_NODE       0x40
#define rmacVNLCU_NODE       0x41

/* MACAO */
#define   rmacUT1		0
#define   rmacUT2		1
#define   rmacUT3		2
#define   rmacUT4		3

#define rmacMACAO_BASE_NODE  0x20
#define rmacMACAO_UT1_NODE   (rmacMACAO_BASE_NODE + rmacUT1)
#define rmacMACAO_UT2_NODE   (rmacMACAO_BASE_NODE + rmacUT2)
#define rmacMACAO_UT3_NODE   (rmacMACAO_BASE_NODE + rmacUT3)
#define rmacMACAO_UT4_NODE   (rmacMACAO_BASE_NODE + rmacUT4)

/* ... */
#define   rmacDL1		0
#define   rmacDL2		1
#define   rmacDL3		2
#define   rmacDL4		3
#define   rmacDL5		4
#define   rmacDL6		5
#define   rmacDL7		6
#define   rmacDL8		7

#define rmacOffset		25 

#define rmacOPD_MESSAGE		( rmacOffset * 0 )

#define rmacDL_MESSAGE		( rmacOffset * 10 )

#define rmacFSU_MESSAGE		( rmacOffset * 20 )

#define   rmacFINITO_CH1	0
#define   rmacFINITO_CH2	1

#define rmacFINITO_MESSAGE	( rmacOffset * 80 )

/*
 * FINITO message structures are accessed at the following offsets ...
 *   CH1 -> (rmacFINITO_MESSAGE + (rmacOffset * rmacFINITO_CH1))
 *   CH2 -> (rmacFINITO_MESSAGE + (rmacOffset * rmacFINITO_CH2))
 */

#define rmacVINCI_MESSAGE	( rmacOffset * 30 )

#define rmacMIDI_MESSAGE	( rmacOffset * 40 )

#define rmacMACAO_MESSAGE	( rmacOffset * 50 )

/*
 * UT message structures are accessed at the following offsets ...
 *   UT1 -> (rmacMACAO_MESSAGE + (rmacOffset * rmacUT1))
 *   UT2 -> (rmacMACAO_MESSAGE + (rmacOffset * rmacUT2))
 *   UT3 -> (rmacMACAO_MESSAGE + (rmacOffset * rmacUT3))
 *   UT4 -> (rmacMACAO_MESSAGE + (rmacOffset * rmacUT4))
 */

#define rmacPRIMA_MESSAGE	( rmacOffset * 60 )

#define   rmacPRIMA_MET		0
#define   rmacPRIMA_FSU_A	1
#define   rmacPRIMA_FSU_B	2

/*
 * PRIMA message structures are accessed at the following offsets ...
 *   MET   -> (rmacPRIMA_MESSAGE + (rmacOffset * rmacPRIMA_MET))
 *   FSU A -> (rmacPRIMA_MESSAGE + (rmacOffset * rmacPRIMA_FSU_A))
 *   FSU B -> (rmacPRIMA_MESSAGE + (rmacOffset * rmacPRIMA_FSU_B))
 */

#define rmacMONITOR_MESSAGE	( rmacOffset * 70 )

/* Common Fields */
#define rmacMSG_HEADER		0
#define rmacTS_TV_SEC		1
#define rmacTS_TV_USEC		2
#define rmacDATA_CHECK		3

/* OPD Fields */
#define rmacRTOFFPOS		4
#define rmacFRINGESDETECTED	5
#define rmacOFFSETVALID         6

/* DL Fields */
#define rmacMEASPOS		4
#define rmacTRKOKFLAG		5

/* Instrument/FSU Fields */
#define rmacOPDCOHERENCE	4
#define rmacOPDCOHERVALID	5
#define rmacINSFRINGESDETECTED  9   

/* Specific FSU Fields */
#define rmacOPDPHASE		6
#define rmacOPDPHASEVALID	7
#define rmacVISIBILITY		8

/* MACAO Fields */
#define rmacWAVEFRONTERROR	4
#define rmacWAVEFRONTVALID	5

/* PRIMA Fields: Metroloy */
#define rmacPRIMET_DELTA        4
#define rmacPRIMET_DELTA_VALID	5

/* PRIMA Fields: FSU A and B */
#define rmacPRIFSU_OPD          4
#define rmacPRIFSU_OPD_VALID	5
#define rmacPRIFSU_GD           6
#define rmacPRIFSU_GD_VALID	7
#define rmacPRIFSU_AMP          8
#define rmacPRIFSU_AMP_VALID	9

#endif /*!RMAC_DEFINES_H*/






