#ifndef slxUtils_H
#define slxUtils_H
/******************************************************************************
* E.S.O. - VLT project
*
* "@(#) $Id: slxUtils.h,v 1.145 2005/07/27 09:00:07 vltsccm Exp $"
*
* who       when      what
* --------  --------  ----------------------------------------------
* jknudstr  04/10/96  created
* epozna    22/01/01  VLTSW20000334 added function slxYankExtensionGenLast
*/

/************************************************************************
 *
 *----------------------------------------------------------------------
 */
#ifdef __cplusplus
extern "C" {
#endif

#include <time.h>

#include "slxBasics.h"
#include "slxDynBuf.h"


ccsCOMPL_STAT slxLoadFile(slxFILENAME   fileName,
			  const char    *envVar,
	 	          slxDYN_BUF    *fileBuf,
  		          ccsERROR      *error);

ccsCOMPL_STAT slxSaveFile(slxFILENAME  fileName,
			  const char   *envVar,
			  slxDYN_BUF   *setupHandle,
			  ccsERROR     *error);

ccsCOMPL_STAT slxGetNextField(const char       *bufPtr,
			      const vltUINT16  maxLen,  
			      char             *nextField,
			      char             **newPos,
			      ccsERROR         *error);

ccsCOMPL_STAT slxGetNextField2(const char       separator,
			       const char       *bufPtr,
			       const vltUINT16  maxLen, 
			       char             *nextField,
			       char             **newPos,
			       ccsERROR         *error);

ccsCOMPL_STAT slxGetNextField3(const char       separator,
			       const char       *bufPtr,
			       char             **nextField,
			       char             **newPos,
			       ccsERROR         *error);

ccsCOMPL_STAT slxGetNextFieldMulti(const char       *separators,
				   const char       *bufPtr,
				   char             **nextField,
				   char             **newPos,
				   ccsERROR         *error);

ccsCOMPL_STAT slxGetPath(const slxFILENAME  fileName, 
			 slxFILENAME        path, 
			 ccsERROR           *error);

ccsCOMPL_STAT slxGetFileName(const slxFILENAME  completeName, 
                             slxFILENAME        fileName,
                             ccsERROR           *error);

void slxGetUTDate(slxUT_DATE utDate);

void slxGenDayTim(slxKEYW_LINE  dayTime);

void slxGenDayTim2(const time_t  timeSecs, slxKEYW_LINE  dayTime);


ccsCOMPL_STAT slxGenDayTimPrec(const vltINT32  precision,
			       slxKEYW_LINE    dayTime,
			       ccsERROR        *error);

#ifndef NOCCS
void slxGenDayTimCcsTime(const ccsTIMEVAL  *time,
			 const vltINT32    precision,
			 slxKEYW_LINE      dayTime);
#endif
 
void slxGenDayTimBasic(const unsigned long tv_sec,
		       const long          tv_usec,
		       const vltINT32      precision,
		       slxKEYW_LINE        dayTime);

#ifndef NOCCS
    ccsCOMPL_STAT slxGetUtcDif(const ccsTIMEVAL   *utcFirst,
			       const ccsTIMEVAL   *utcLast,
			       vltUINT32          *timeDif,
			       ccsERROR           *error);
#endif

void slxGetUTTime(vltUINT32 *utTime);

void slxGenUTC(const unsigned long tv_sec,
	       const long          tv_usec,
	       const vltINT32      precision,
	       slxKEYW_LINE        utcTime);

int slxSkipLine(const char  *line);

void slxStrToUpper(char *str);

void slxStripQuotes(char *str);

char *slxStrDup(const char *string);

ccsCOMPL_STAT slxBuildInsFileName(const slxFILENAME  insPath1,
				  const slxFILENAME  insPath2,
				  const slxFILENAME  insPath3,
				  const slxFILENAME  fileName,
				  slxFILENAME        completeName,
				  ccsERROR           *error);

ccsCOMPL_STAT slxBuildInsUserDir(slxFILENAME  insUserDir,
				 char         *user,
				 ccsERROR     *error);

ccsCOMPL_STAT slxPrintError(ccsERROR  *error);

ccsCOMPL_STAT slxAssembleKeyword(const slxCATEGORY   category,
				 const slxSUBSYSTEM  subSystem,
				 const slxPARAMETER  parameter,
				 slxKEYW_LINE        keyword,
				 ccsERROR            *error);

char *slxAssKey(const char *key1, const int index1, ...);

char *slxAssKey2(const char *key1, ...);

vltLOGICAL slxIsShortFITS(const slxKEYW_LINE  keyword);

char slxGetLastChar(char *string);

void slxSetLastChar(char  *string,
		    char  chr);

ccsCOMPL_STAT slxKeywClass2No(const char        *classStr, 
			      slxKEYWORD_CLASS  *classNo,
			      ccsERROR          *error);

ccsCOMPL_STAT slxGetValueEnvVar(const slxFILENAME  envVar,
				char               **destBuf,
				ccsERROR           *error);


ccsCOMPL_STAT slxBitPix2NoBytes(const vltINT32  bitPix,
				vltINT32        *noOfBytes,
				ccsERROR        *error);

ccsCOMPL_STAT slxGetKeywordIndex(const slxKEYW_LINE  keyword, 
				 vltINT32            *index,
				 ccsERROR            *error);

ccsCOMPL_STAT slxResolvePath(const slxFILENAME  orgPath,
			     char               **completePath,
			     ccsERROR           *error);
    
void slxReplaceIndex(slxKEYW_LINE  keyword, vltINT32 *index);

ccsCOMPL_STAT slxProbeReplaceIndeces(const slxKEYW_LINE  keyword,
				     slxKEYW_LINE        subStKeyw,
				     ccsERROR            *error);

vltLOGICAL slxStr2Logical(const char  *strLogical);

char *slxGetExtension(const slxFILENAME fileName);

void slxCheckExtension(slxFILENAME fileName, const slxFILENAME extension);

vltLOGICAL slxCheckExtension2(slxFILENAME fileName, const char *extension);

void slxYankExtension(slxFILENAME fileName, const slxFILENAME extension);

void slxYankExtensionGen(slxFILENAME fileName);

void slxYankExtensionGenLast(slxFILENAME fileName);

void slxYankTrailNewLines(char *str);

void slxYankLastPath(slxFILENAME  path);

ccsCOMPL_STAT slxSplitFileName(const slxFILENAME  completeName,
			       slxFILENAME        path,
			       slxFILENAME        fileName,
			       slxFILENAME        extension,
			       ccsERROR           *error);

void slxDetermineType(const char   *value,
		      slxPAR_TYPE  *type);

void slxTrimString(char *string, char *trimChars);

ccsCOMPL_STAT slxSplit(const char       *separators, 
		       const char       *stringPtr, 
		       const vltINT32   maxNoOfSubStr, 
		       slxKEYW_LINE     subStrings[], 
		       vltINT32         *noOfSubStr, 
		       ccsERROR         *error);

ccsCOMPL_STAT slxStopWatch(const vltINT32    watchNo,
			   const vltLOGICAL  start,
			   vltUINT32         *timeSec,
			   vltUINT32         *timeUSec,
			   ccsERROR          *error) ;

#ifdef __cplusplus
}
#endif

#endif /*!slxUtils_H*/
