#***********************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: audioFlush.tcl,v 1.13 2005/10/28 08:40:22 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# eallaert  2005-03-01  first version
# 
#
#************************************************************************
#   NAME
#   audioFlush - flush the sounds currently being sent
#   
#   SYNOPSIS
#   \fBaudioFlush\fR
#   
#   DESCRIPTION
#   This procedure will wait till the sending of any audio-file initiated
#   previously via an audioPlay call is completed. This guarantees that the
#   corresponding sound server will deal with the full audio-file.
#   This is useful if you need to ensure that the sound is being played before
#   you proceed, or also if you want to exit your application without 
#   interrupting the sounds being played.
#
#   FILES
#   
#   ENVIRONMENT
#   
#   RETURN VALUES
#   None.
#
#   CAUTIONS
#   
#   EXAMPLES
#
#   SEE ALSO
#   audioPlay(n)
#
#------------------------------------------------------------------------
#
# Ensure the namespace ::audio exists, and the var audio::info(refCnt) as well
audio::_initNamespace

proc ::audio::audioFlush {} {
    variable refCnt

    while {$refCnt > 0} {
	vwait audio::refCnt
    }
}
