#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: bobRegisterTplUnknown.tcl,v 1.145 2005/10/27 09:07:09 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mbec		28/07/97  header update
#

#************************************************************************
#   NAME
#   _tpl_unknown - the unknow handler for bob
# 
#   SYNOPSIS
#   _tpl_unknown <args>
# 
#   DESCRIPTION
#	resolve the call to:
#		* checkAbortFlag
#               * finishOB
#               * getResult
#               * pafReady
#		* seeBobVars
#		* sendCmd
#		* sendObsKeys
#               * setCallBack
#               * setResult
#		* tplLog
#
#	in the ::BobTPL scope; consequently, these procs will be found
#       without giving the explicit namespace
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#	dialogs are kept with tk
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS
#
#------------------------------------------------------------------------
#
# register new unknown handler

proc registerTplUnknown {} {
    
    unknown_handler bobtpl ::_tpl_unknown
}

proc ::_tpl_unknown {args} {
    # only handles known unknown ...
    set publicProcs [list \
	    checkAbortFlag \
	    finishOB \
	    getResult \
	    pafReady \
	    seeBobVars \
	    sendCmd \
	    sendObsKeys \
	    setCallBack \
	    setResult \
	    tplLog\
	    ]
    
    if {[lsearch -exact $publicProcs [lindex $args 0]] >= 0} {
	return [namespace eval ::BobTPL $args]
    } else {
	# procName not in our list ... let the other handlers do their job
	return -code continue
    }
}

