#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: feditHelpFile.tcl,v 2.11 2003/11/12 09:10:35 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    14/11/95  created
# mcomin    04/12/95  Fixed bug when par(OLD_MEMO) not defined 
#           01/10/96  Fixed buf in set par(STORE_HELP)
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc feditRestoreHelpFile {} {
   global par myHelpFile

   if {[cequal $par(EDIT_MODE) "r"]} { return }
   if {$myHelpFile == ""}            { return }

   if {[findModuleFile ERRORS/HELP/${myHelpFile}~] != "" } {
      $par(wdgErrHelp) deleteText 0.0 end ;     # Clear Help File
      set tmp [internal::errReadHelpFile ${myHelpFile}~ $par(EDIT_MODE)]
      $par(wdgErrHelp) insertText 0.0 $tmp

      if {[string trim $tmp " \n"] == ""} {
         set msg "Help File   ${myHelpFile}~   recovered but EMPTY"
      }
  
   } else {
         set msg "Help File   ${myHelpFile}~   NOT FOUND"
   }

   if {[info exists msg]} { $par(SH_AREA) displayText $msg }
}



#-----------------------------------------------------------------------------
#                OBSOLETE --- NOT USED !!
#
#
# PROCEDURE : feditReadHelpFile - Reads the help file and strips off the
#                                 file header. It returns the file content.
#-----------------------------------------------------------------------------

proc feditReadHelpFile { helpFile mode } {
   
   if {$mode == "r" } {
      set helpPath [findVLTFile ERRORS/HELP/${helpFile} no ]
   } else {
      set helpPath [findModuleFile ERRORS/HELP/${helpFile}]
   }
   
   if {$helpPath == "" } { return "" }
   
   set fileSize [file size $helpPath]   
   set fh       [open $helpPath "r"]

   # Skip header
   
   while { [gets $fh buf] != -1 } {
     set char [string index $buf 0 ]
     if {$char != "#" && $char != "\n" } { break }
   }

   append buf [read $fh $fileSize]  
   close  $fh
   return $buf
}


#-----------------------------------------------------------------------------
# PROCEDURE : feditStoreHelpFile - 
#-----------------------------------------------------------------------------

proc feditStoreHelpFile { helpFile } {
   global par myMnemonic deleteHelpList myHelpFile 

   # Check if the ERROR/HELP directory exists

   set par(HELP_PATH) [getRelPath $par(MODULE) ERRORS/HELP]
      
   if {[file exists $par(HELP_PATH)]==0} {
      set tmp "Module Directory Structure"
      append tmp "\nMISSING ERRORS/HELP directory"
      append tmp "\nCannot Save help File"
         
      tk_dialog .dialog "Dialog Box" $tmp info 0 OK 
      return      
   }   

   set buf       [$par(wdgErrHelp) getText 0.0 end ]
   set helpSize  [string length [string trim $buf " "]]

   # Check if the user changed the mnemonic, then substitute all 
   # occurrences of the old mnemonic with the new one.

   if {[info exists par(OLD_MEMO)] == 0 } { set par(OLD_MEMO) "" }

   if {$myMnemonic != $par(OLD_MEMO)} {
      set tmp [$par(wdgErrHelp) getText 0.0 end]
      regsub $par(OLD_MEMO) $tmp $myMnemonic buf

      $par(wdgErrHelp) deleteText 0.0 end  ; # Erase  old text
      $par(wdgErrHelp) insertText 0.0 $buf ; # Insert new text
      
      if { $helpSize } { 
         set par(STORE_HELP) 1 ;        # Force writing of the new help file
      } else {
         set par(STORE_HELP) 0 ;
      }

      # Check if the name of the help file matches the mnemonic
 
      set helpFile [feditRemoveHelp $helpFile]
   }

#   puts "DBG > HELP_PATH = $par(HELP_PATH) , $helpFile store = $par(STORE_HELP)"

   #
   # Check if the help file has been modified : variable par(STORE_HELP) 
   # is also updated the user modifies the help text.
   #

   if {$par(STORE_HELP)} {
   
      if {[string trim ${helpFile} " "] == "" } {

	   if {![cequal [string trim $buf " \n" ] ""]} {
              set    tmp "CANNOT STORE HELP FILE\n"
              append tmp "File name is NULL"      
              tk_dialog .dialog "Dialog Box" $tmp info 0 OK
           }

         set par(STORE_HELP) 0
         return
      }

      append par(HELP_PATH) "/${helpFile}"
      set fh [open $par(HELP_PATH) "w+"]

      feditWriteHeader "help" $fh "Error Help File" ; # Write file header

      puts  $fh $buf
      flush $fh
      close $fh
   }
   set par(STORE_HELP) 0
}

#-----------------------------------------------------------------------------
# PROCEDURE : feditCheckHelp - 
#-----------------------------------------------------------------------------

proc feditRemoveHelp { helpFile {removeFlag {0}} } {
   global par myMnemonic deleteHelpList myHelpFile

   if { $helpFile != "$par(OLD_MEMO).hlp" } { return $helpFile }

   set helpFile "${myMnemonic}.hlp"
   lappend deleteHelpList $myHelpFile
 
   # If the mnemonic is used again, take it away from the list if it's not
   # explicitly 'deleted'

   if { $removeFlag == 0} {
      if {[set idx [lsearch $deleteHelpList $helpFile]] != -1 } {
         set deleteHelpList [lreplace $deleteHelpList $idx $idx]
      }
      set myHelpFile $helpFile ;  # Update current help file name
   }

#   puts "DBG > deleteHelpList = $deleteHelpList"
   return $helpFile
}



#-----------------------------------------------------------------------------
# PROCEDURE : feditHelpTemplate - 
#-----------------------------------------------------------------------------

proc feditHelpTemplate {} {
   global par myMnemonic

   set    tmp "NAME\n  $myMnemonic - <Brief Description>\n\n"
   append tmp "DESCRIPTION\n\n  <Extensive Description>\n\n"
   append tmp "CAUTION\n\n  <Specific conditions>\n"

   $par(wdgErrHelp) deleteText 0.0 end  ; # Erase  old text
   $par(wdgErrHelp) insertText 0.0 $tmp ; # Insert new text 
   set par(STORE_HELP) 1
}

#-----------------------------------------------------------------------------
# PROCEDURE : feditSetHelpFlag - Takes car of the user's chamges
#                                It is bound to the <Any-Key> event
#-----------------------------------------------------------------------------

proc feditSetHelpFlag { key } {
   global par
   if {$key != ""} { set par(STORE_HELP) 1 }
}

#
# ___oOo___
