#
# E.S.O. - VLT project - 1995
#
# "@(#) $Id: feditMainPanel.tcl,v 2.11 2003/11/12 09:10:35 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    ??/??/??  created
# mcomin    12/11/95  Modified to serve both log and error editors
# ------------------
# mcomin    14/03/96  Ported to TK4.0 and itcl2.0
#           12/11/97  Take away search mode menu
#

#-----------------------------------------------------------------------------
# PROCEDURE : createMainPanel  -
#-----------------------------------------------------------------------------

proc feditMainPanel { what } {
global totalElem  par  listView gvar

set listFormat $par(${what}_DEF)

#
#  Frame Definitions 
#
set top [frame .top ]
set menuFrame  [frame $top.menuFrame]
set f1 [frame $top.f1]
set f2 [frame $top.f2 -relief raised -bd 2]
set f3 [frame $top.f3]

pack $top -fill both -expand yes
pack $menuFrame -fill x
pack $f1  -fill x    -padx 5 -pady 3
pack $f2  -fill both -expand yes -padx 5 -pady 3
pack $f3 -fill x -pady 3

#
# Create menuBar
#

feditMenuBar $menuFrame ;     # Create the menuBar

#
# Create listbox
#

frame $f2.r1 ; frame $f2.r2
pack $f2.r1   -fill x
pack $f2.r2   -fill both -expand yes

set  par(wdgErrList) $f2.r2.listOfErrors

label  $f2.r1.listFormat -text $listFormat -font $par(FONT12)
UifListBox $par(wdgErrList) -geometry 5x1

$par(wdgErrList)  setBind <ButtonPress-1>  { feditConfigPanel }

pack $f2.r1.listFormat -pady 2 -side left -fill x 
pack $par(wdgErrList) -side left -fill both -expand yes

#
# Create Short Help Area
#
set shFrame  [frame $top.shFrame  -relief raised -bd 2 ]
pack $shFrame -fill x -padx 5 -pady 5

set par(SH_AREA) $shFrame.sh
UifShortHelp $par(SH_AREA)
pack $par(SH_AREA) -fill x

#
# Add action buttons at the bottom
#

set actFrame [frame $shFrame.actFrame]
set par(actFrame) $actFrame

button $actFrame.b1 -width 8 -text "CLEAR"   -command { feditClearConfig }
button $actFrame.b2 -width 8 -text "ADD"     -command { feditRecAdd }
button $actFrame.b3 -width 10 -text "REPLACE" -command { feditRecModify }
button $actFrame.b4 -width 8 -text "DELETE " -command feditRecDelete -fg red
button $actFrame.select   -text " SEARCH " -command { feditRecSearch }

button $actFrame.rwd -bitmap @[findVLTFile bitmaps/rewind.xbm]  \
      -command {global myIndex ; set myIndex [feditGetConfig PREV $myIndex] }
button $actFrame.fwd -bitmap @[findVLTFile bitmaps/forward.xbm] \
      -command {global myIndex; set myIndex [feditGetConfig NEXT $myIndex] }

UifOptionButton $actFrame.searchMode -selectMode value\
                -itemList {"by Mnemonic" "by Number"} -default $par(BY_MEMO)\
                -itemValue [list $par(BY_MEMO) $par(BY_ID)]\
                -length 10 -variable gvar(searchMode)

set gvar(searchMode)  $par(BY_MEMO)
                  
pack $actFrame -fill x
pack  $actFrame.b2  $actFrame.b3  -side left  -pady 10 -padx 5
pack  $actFrame.b1  $actFrame.b4  -side left  -pady 10 -padx 5
pack  $actFrame.fwd  $actFrame.searchMode $actFrame.select $actFrame.rwd -side right -padx 3

#
# Create Error Configuration Area
#

feditErrorConfig $f3

}


proc feditMenuBar { top } {
   global mbOpt insMenu par mbFile

   # Menubar
   set menuBar  [ makeMenuFrame $top ]
   #
   #  File Menu
   #
   set mbFile [addMenu $menuBar  File  1]; 
   
   addMenuCmd $mbFile "New"           0  { feditNewFile ; feditClearConfig}
   addMenuCmd $mbFile "Open (Read Only)"  1  { feditOpenMod "r"  } 
   addMenuCmd $mbFile "Open"          0  { feditOpenMod "r+" }
   $mbFile     add     separator
   $mbFile     add     separator
   addMenuCmd $mbFile  "Generate Files"  0 { feditGenFiles }
   $mbFile     add     separator
   addMenuCmd $mbFile "Quit"          0  { feditQuitEditor }
   	    	    
   #
   #  "Options" Menu
   #

   set mbOpt  [addMenu $menuBar "Options" 1];
    
   addMenuCmd $mbOpt  "Show Include File"    0 {feditShowFile include}
   addMenuCmd $mbOpt  "Show Definition File" 0 {feditShowFile definition}
   addMenuCmd $mbOpt  "Show Index File"      0 {feditShowFile index}
   $mbOpt     add     separator
   $mbOpt     add     separator
   addMenuCmd $mbOpt  "Cleanup Help Files" 0 { exec feditCleanHelpFiles ALL &}
   $mbOpt     add     separator
   addMenuCmd $mbOpt  "Check All Log Formats" 0  { feditCheckAll }
     
   #
   #  "Install" Menu
   #

   set insMenu [addMenu $menuBar "Install" 1];
	
   addMenuCmd $insMenu "Install Files" 0  {feditInstall $par(MODULE)}
   
   #  Search Mode Menu

#   set searchMenu [addMenu $menuBar "Search Mode" 1];    
#   
#   addMenuRb $searchMenu "By Number"   0 "" searchMode $par(BY_ID)
#   addMenuRb $searchMenu "By Mnemonic" 0 "" searchMode $par(BY_MEMO)
   
   #
   #  "Help" Menu
   #
    
   set mbHelp [addMenu $menuBar  Help  1 right];      # Help Menu

   addMenuCmd $mbHelp "Extended Help"  0  {puts "Not Implemented"}
}
