#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: iracqUifCfg.tcl,v 1.113 2005/09/13 07:27:23 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# jstegmei  26/05/99  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

# select system configuration file
proc iracqLoadSysConfig {} {
    global gvar cv

    set dir $gvar(iracqSysCfgBase)
    set filter "*.cfg"

    iracqSelectFile iracqSysConfigFile "Load System Configuration" \
	    $dir $filter  

    if {$gvar(iracqSysConfigFile) == ""} {
	return
    }
    set gvar(iracqSysCfgBase) [file dirname $gvar(iracqSysConfigFile)]
    if {[iracqCmdSysConf $gvar(iracqSysConfigFile)]} {
	if {![iracqGetConfig]} {
	}
    }

    iracqFileChanged sysCfg \
	    "$gvar(iracqSysConfigFile)" 1
    iracqFileChanged detCfg \
	    "$gvar(iracqDetConfigFile)" 1

    [$cv.iracqSysVoltage component uifEntry] xview end
    [$cv.iracqSysClk component uifEntry] xview end
    [$cv.iracqSysSeq component uifEntry] xview end
}

# select detector configuration file
proc iracqLoadDetConfig {} {
    global gvar cv

    set dir $gvar(iracqDetCfgBase)
    set filter "*.dcf"

    iracqSelectFile iracqDetConfigFile "Load Detector Configuration" \
	    $dir $filter 

    if {$gvar(iracqDetConfigFile) == ""} {
	return
    }

    set gvar(iracqDetCfgBase) [file dirname $gvar(iracqDetConfigFile)]

    if {[iracqCmdDetConf $gvar(iracqDetConfigFile)]} {
	if {![iracqGetConfig]} {
	}
    }

    iracqFileChanged detCfg \
	    "$gvar(iracqDetConfigFile)" 1
    
    [$cv.iracqSysVoltage component uifEntry] xview end
    [$cv.iracqSysClk component uifEntry] xview end
    [$cv.iracqSysSeq component uifEntry] xview end
}

# browse voltage file
proc iracqBrowseVolt {} {
    global gvar cv

    set dir $gvar(iracqSysVoltBase)
    set filter "*.*"

    iracqSelectFile iracqSysVoltageB "Load Voltage File" \
	    $dir $filter 

    if {$gvar(iracqSysVoltageB) == ""} {
	return
    }

    set gvar(iracqSysVoltBase) [file dirname $gvar(iracqSysVoltageB)]

    #download file
    if {[iracqCmdLoadVoltage $gvar(iracqSysVoltageB)]} {
	set gvar(iracqSysVoltage) $gvar(iracqSysVoltageB)
    }

    [$cv.iracqSysVoltage component uifEntry] xview end
}


# browse clock file
proc iracqBrowseClk {} {
    global gvar cv

    set dir $gvar(iracqSysClkBase)
    set filter "*.clk"

    iracqSelectFile iracqSysClkB "Load Clock File" \
	    $dir $filter 

    if {$gvar(iracqSysClkB) == ""} {
	return
    }

    set gvar(iracqSysClkBase) [file dirname $gvar(iracqSysClkB)]

    #download file
    if {[iracqCmdLoadClk $gvar(iracqSysClkB)]} {
	set gvar(iracqSysClk) $gvar(iracqSysClkB)
    }

    [$cv.iracqSysClk component uifEntry] xview end
}

# browse sequence file
proc iracqBrowseSeq {} {
    global gvar cv

    set dir $gvar(iracqSysSeqBase)
    set filter "*seq"

    iracqSelectFile iracqSysSeqB "Load Sequence File" \
	    $dir $filter 

    if {$gvar(iracqSysSeqB) == ""} {
	return
    }

    set gvar(iracqSysSeqBase) [file dirname $gvar(iracqSysSeqB)]

    #download file
    if {[iracqCmdLoadSeq $gvar(iracqSysSeqB)]} {
	set gvar(iracqSysSeq) $gvar(iracqSysSeqB)
    }

    [$cv.iracqSysSeq component uifEntry] xview end
}  

# browse flatfield
proc iracqBrowseFlatfield {} {
    global gvar cv

    set dir $gvar(iracq_flatfieldBase)
    set filter "*.fits"

    iracqSelectFile iracq_flatfield "FLATFIELD" \
	    $dir $filter 

    if {$gvar(iracq_flatfield) == ""} {
	return
    }

    set gvar(iracq_flatfieldBase) [file dirname $gvar(iracq_flatfield)]
}

# browse badpix
proc iracqBrowseBadpix {} {
    global gvar cv

    set dir $gvar(iracq_badpixBase)
    set filter "*.fits"

    iracqSelectFile iracq_badpix "BAD-PIXEL-MASK" \
	    $dir $filter 

    if {$gvar(iracq_badpix) == ""} {
	return
    }

    set gvar(iracq_badpixBase) [file dirname $gvar(iracq_badpix)]
}

# save voltage file
proc iracqSaveVolt {} {
    global gvar cv

    set dir $gvar(iracqSysVoltBase)
    set filter "*.*"

    iracqSelectFile iracqSysVoltageB "Load Voltage File" \
	    $dir $filter 

    if {$gvar(iracqSysVoltageB) == ""} {
	return
    }

    set gvar(iracqSysVoltBase) [file dirname $gvar(iracqSysVoltageB)]

    if {[file exists $gvar(iracqSysVoltageB)]} {
	if {![iracqTkDialog2 \
		"Warning" "The file $gvar(iracqSysVoltageB) already exists!\
		\nOverwrite?"]} {
	    return 0
	}
    }

    #save voltage to file
    if {[iracqCmdSaveVoltage $gvar(iracqSysVoltageB)]} {
	set gvar(iracqSysVoltage) $gvar(iracqSysVoltageB)
    }
}

# get current configuration
proc iracqGetConfig {} {

    global cv gvar
    global iracqParam

    set confStr ""
    if {!$gvar(iracqCCS)} {
	# get current status
	if {![iracqGetState]} {
	    return 0
	}
	
	# execute getconf command
	if {![iracqFunction "getconf" 0 confStr]} {
	    return 0
	}
	
	# skip first line
	iracqSgets confStr
	
	# extract configuration values
	set gvar(iracqCfgBase) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqDetConfigFile) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqDetCfgBase) [file dirname $gvar(iracqDetConfigFile)]
	set gvar(iracqDetName) [iracqScanString [iracqSgets confStr]]
	set value [iracqScanString [iracqSgets confStr]]
	iracqRound value 4 "e"
	set gvar(iracqMinDit) $value
	set value [iracqScanString [iracqSgets confStr]]
	iracqRound value 4 "e"
	set gvar(iracqDit) $value
	set gvar(iracqWinNxMax) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqWinNyMax) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqWinStartX) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqWinStartY) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqWinNx) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqWinNy) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqHwWin) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqCldcList) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqDetCldc) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqDetClk) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqRspeedF) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqRspeedA) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSysCldc) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSysVoltage) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSysClk) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSysSeq) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSeqMode) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSysNumAdc) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSysAcqProc) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqRm) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqOpMode) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSeqCont) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqNoNcReset) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqSeqBaseName) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqReqFileName) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqNamingType) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqDataCube) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqRtdInt) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqRtdHost) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqRtdDisp) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqRtdCmd) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqExtFits) [iracqScanString [iracqSgets confStr]]
	set value [iracqScanString [iracqSgets confStr]]
	set gvar(iracqExpTime) [iracqSec2Str $value]
	set gvar(iracq_chopFreq) [iracqScanString [iracqSgets confStr]]
	set gvar(iracqDetNumRm) [iracqScanString [iracqSgets confStr]]
	for {set i 0} {$i < $gvar(iracqDetNumRm)} {incr i 1} {
	    set gvar(iracqDetRm$i) [iracqScanString [iracqSgets confStr]]
	}

	if {$gvar(iracqRtdCmd) == ""} {
	    $gvar(iracqBcv).iracqStartRtd disable
	} else {
	    $gvar(iracqBcv).iracqStartRtd enable
	}

	[$cv.iracqSysVoltage component uifEntry] xview end
	[$cv.iracqSysClk component uifEntry] xview end
	[$cv.iracqSysSeq component uifEntry] xview end

	set tmp [file tail $gvar(iracqDetConfigFile)]
	set gvar(iracqDetConfigName) [file rootname $tmp]

	# update readout mode options
	iracqRmUpdate
	
	# configure ADC-options
	iracqAdcCfg
	iracqAdcUpdate
	
	set gvar(iracqSysCldcT) $gvar(iracqSysCldc)
	set gvar(iracqSysVoltageT) $gvar(iracqSysVoltage)
	set gvar(iracqSysClkT) $gvar(iracqSysClk)
	set gvar(iracqSysSeqT) $gvar(iracqSysSeq)
	set gvar(iracqSysAcqProcT) $gvar(iracqSysAcqProc)
	
	# update frame list
	iracqCmdFrameList

	# try to get parameter setup
	if {[iracqCmdGetParam 0]} {
	    if {$gvar(iracqNewParam)} {
		iracqParamUpdate
	    }
	} 

	if {[info exists iracqParam(DET.CHOP.ST)]} {
	    set gvar(iracq_chopState) $iracqParam(DET.CHOP.ST)
	}

	# try to get voltage setup
	iracqUpdateCldcList 
	if {[iracqFunction "vsetup" 0 tmpStr]} {
	    iracqScanVsetup $tmpStr
	}
	
    } else {
	if {![iracqCfgDb]} {
	    return 0
	}
	iracqUpdateTelValue
    }
    
    return 1
}

# get current status
proc iracqGetState {} {
    global gvar cv

    if {$gvar(iracqCCS)} {
	# this is not needed here
	return 1
    }

    set statStr ""

    # execute status command
    if {![iracqFunction "status" 0 statStr]} {
	return 0
    }

    # extract status values
    set gvar(iracqSrvState) [iracqScanString [iracqSgets statStr]]
    
    set gvar(iracqSeqState) [iracqScanString [iracqSgets statStr]]
    set gvar(iracqCldcState) [iracqScanString [iracqSgets statStr]]
    set gvar(iracqAcqState) [iracqScanString [iracqSgets statStr]]
    return 1
}

# update readout mode options
proc iracqRmUpdate {} {
    global gvar

    if {$gvar(iracqRmOption) == ""} {
	return 1
    }

    if {![winfo exists $gvar(iracqRmOption)]} {
	return 1
    }

    $gvar(iracqRmOption) deleteEntry 0 last  
    for {set i 0} {$i < $gvar(iracqDetNumRm)} {incr i 1} {
	$gvar(iracqRmOption) addItem $gvar(iracqDetRm$i) \
		"iracqCmdSetReadoutMode $gvar(iracqDetRm$i)"  
    }

}

#
# ___oOo___
