#*******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: irlToolLib.tcl,v 1.104 2005/09/12 09:21:02 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# jstegmei  09/02/99  created
#

#************************************************************************
#   NAME
#   irlToolLib.tcl - some tools for irace loops
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#   some tools for irace loops
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

# toplevel file selection box
proc irlSelectFileX {fileId title dir filter args} {

    global par fsbReturn gvar irlFileActive

    set c ".irlSelFile"; 
    set fsb $c.fsb
    set fsbOld 0
    
    set gvar($fileId) ""
    set gvar(irlFileId) $fileId

    if {[winfo exists $c] == 0} {
	# get current Directory
	set home [exec pwd]
	toplevel $c
	set fsb  $c.fsb
	
	UifFileSelBox  $fsb -topLevel $c -dirGeometry 30x10 \
		-fileGeometry 25x10 -iconify 1
	pack $fsb -fill both -expand 1 
	
	bind $c <Visibility> "raise $c"
	wm group $c [winfo toplevel [winfo parent $c]]
	wm minsize $c 400 395
	wm title   $c $title

	# center
	wm withdraw $c
	update idletasks
	set x [expr {[winfo screenwidth $c]/2 - [winfo reqwidth $c]/2 \
			 - [winfo vrootx [winfo parent $c]]}]
	set y [expr {[winfo screenheight $c]/2 - [winfo reqheight $c]/2 \
			 - [winfo vrooty [winfo parent $c]]}]
	wm geom $c +$x+$y
	wm deiconify $c
	
	catch {$fsb CD $dir}

	if {[catch {$fsb filter $filter}]} {
	    set fsbOld 1

	    catch {$fsb FILTER $filter}
	}
    } else {
	catch {$fsb CD $dir}
	if {[catch {$fsb filter $filter}]} {
	    set fsbOld 1
	    catch {$fsb FILTER $filter}
	}
	wm title     $c $title
	wm deiconify $c
    }

    # raise widget
    raise $c

    if {[info exists irlFileActive($fileId)]} {
	if {$irlFileActive($fileId)} {
	    set filePath ""
	    return filePath
	}
    }

    # set active flag for fileId
    set irlFileActive($fileId) 1

    # wait until the user does something ...
    if {$fsbOld} {
	vwait fsbReturn
	set filePath $fsbReturn
    } else {
        uplevel #0 vwait ${fsb}_fsbReturn
        set filePath [uplevel #0 set ${fsb}_fsbReturn]
    }

    # hide widget
    wm withdraw $c

    # set filename
    if {[string length $filePath] < 1} { 
	set gvar($gvar(irlFileId)) ""
    } else {	
	set gvar($gvar(irlFileId)) $filePath
    }

    # clear active flags
    foreach i [array names irlFileActive] {
	set irlFileActive($i) 0
    }
    
    return $filePath
}

# toplevel file selection box
proc irlSelectFile {fileId title dir filter args} {
    global gvar 

    set panSelFileName [panSelectFile $dir $filter \
	    -title $title -top ".$fileId" -cd]

    # set filename
    set gvar($fileId) $panSelFileName

    return $panSelFileName
}

# text result box
proc irlTextBox {w width height name} {
    global gvar 

    frame $w.box 
    pack $w.box -side top -fill both -expand 1

    text $w.text -relief sunken -fg black -bd 2 \
	    -cursor left_ptr \
	    -width $width -height $height \
	    -wrap none -state disabled \
	    -xscrollcommand "$w.scrollx set" \
	    -yscrollcommand "$w.scrolly set" 


    set gvar($name) $w.text

    $w.text tag configure err -foreground red3
 
    scrollbar $w.scrolly -command "$w.text yview" \
	    -orient vertical -cursor left_ptr
    
    scrollbar $w.scrollx -command "$w.text xview" \
	    -orient horizontal -cursor left_ptr
   
    pack $w.scrollx -side bottom -fill x -in $w.box
    pack $w.scrolly -side right -fill y -in $w.box
    pack $w.text -side left -fill both -expand 1 -in $w.box
}

# clear result display
proc irlClearResult {} {
    global gvar

    # clear result disply
    $gvar(irlText) configure -state normal
    $gvar(irlText) delete 1.0 end
    $gvar(irlText) configure -state disabled

}

# add to action history
proc irlAddResult {outputString} {
    global gvar 

    # enable verbose box for insertion
    $gvar(irlText) configure -state normal
    
    # append result to diagText
    $gvar(irlText) insert end "$outputString"
    $gvar(irlText) see end 
    
    # disable insertion 
    $gvar(irlText) configure -state disabled
}

#
# ___oOo___
