#
# E.S.O. - VLT project
#
# "@(#) $Id: configBarChart.tcl,v 5.34 2005/09/26 12:44:17 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    ??/??/??  created
# mcomin    18/10/95  Add event mechanism
#
#

#-----------------------------------------------------------------------------
# PROCEDURE : barChartPanel -  Creates config. panel for UifBarChart
#-----------------------------------------------------------------------------

proc barChartPanel { idx top } {
   global wdgConfig

   label  $top.dummy -width $wdgConfig(lblWidth) -font $wdgConfig(lblFont) 
   checkbutton  $top.axis  -text "Show Axis"  -variable ckAxis($idx) \
                -width 10 -anchor w
   checkbutton  $top.ticks -text "Show Ticks" -variable ckTicks($idx) \
                -width 10 -anchor w

   pack $top.dummy $top.ticks $top.axis -side left
}

#------------------------------------------------------------------------------
# PROCEDURE : configUifBarChart - Updates the data structures describing the
#                                    configuration of the UifBarChart Class
#------------------------------------------------------------------------------

proc configUifBarChart { idx cv w name } {
   global i_min i_max i_default 
   global ckDbMin ckDbMax ckOrientation ckAxis ckTicks

   set min [getValue $idx $name [getWdgConfig $idx wdgMin] ckDbMin]
   set max [getValue $idx $name [getWdgConfig $idx wdgMax] ckDbMax]

   $cv.$name configure -label [getConfigInput $idx wdgLabel] \
                       -orient $ckOrientation($idx) -minVal $min \
                       -maxVal $max -axis $ckAxis($idx) -ticks $ckTicks($idx)
       
   if { $ckDbMin($idx) == 0 } { 
      saveWidget $name $i_min  $min 
   } else {
      saveWidget $name $i_min  0   
   }   
   
   if { $ckDbMax($idx) == 0 } { 
      saveWidget $name $i_max  $max 
   } else {
      saveWidget $name $i_max  0     
   }
}

#------------------------------------------------------------------------------
# PROCEDURE : displayUifBarChart - Updates the configuration panel according
#                               to the current UifBarChart Class configuration
#------------------------------------------------------------------------------

proc displayUifBarChart { idx cv w name } {
   global  ckAxis ckOrientation ckTicks i_default
   
   setConfigEntry $idx wdgLabel [string trimright [$cv.$name cget -label]]

   displayMin $idx $name
   displayMax $idx $name 

   set ckOrientation($idx) [$cv.$name cget -orient]
   set ckAxis($idx)        [$cv.$name cget -axis]
   set ckTicks($idx)       [$cv.$name cget -ticks]
}







