#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: configDbEvent.tcl,v 5.34 2005/09/26 12:44:19 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    06/10/95  created
# mcomin    20/02/96  Bug fixing in panEvtDbOperation
#           26/08/96  Add check if widget exists in panEvtDbAttach
#           18/08/98  Fill automatically event script to default value 
#                     if field is empty
#
#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS      
#
#------------------------------------------------------------------------
#

#----------------------------------------------------------------------------
# PROCEDURE : databaseConfig -
#----------------------------------------------------------------------------

proc databaseConfig { idx top } {
    global ckDbMode panEvtScript panEvtFilter
    
    $top configure -relief raised -bd 2
    
    set row1  [frame $top.r1]
    set row2  [frame $top.r2]
    set row2b [frame $top.r2b]
    
    set font12 "-Adobe-courier-medium-r-normal--12*-iso8859-1"

    label $top.r1.title -text "Database Configuration" \
	-font "-Adobe-helvetica-bold-r-normal--12*-iso8859-1"
    
    pack $row1  -fill x -pady 3
    pack $row2b -fill x
    pack $row2  -fill x -pady 2
  
    radiobutton $row1.poll -text "Poll"  -anchor w  -value "dbPoll"\
	-variable ckDbMode($idx)
    radiobutton $row1.evt  -text "Event" -anchor w -value "dbEvent" \
	-variable ckDbMode($idx) -command "panCkEvtScript $idx"
    
    UifOptionButton $row1.filter -length 2 -variable panEvtFilter($idx)  \
	-itemList {"<" "<=" "=" ">" "=>" "!=" "w"} -default "!="\
	-font $font12
    
    label  $row1.l2  -text "Filter "      -font $font12
    label  $row2b.l3 -text "Event Script" -font $font12
    
    button $row2.defScript -text "Default" -font $font12 \
	-command "panSetDefaultEvt $idx"
    
    entry  $row2.script -textvariable panEvtScript($idx) -width 50
    
    pack  $top.r1.title          -side left  -padx 10
    pack  $row1.poll   $row1.evt -side left  -padx 3
    pack  $row1.filter $row1.l2  -side right -padx 3

    pack  $row2b.l3  -side left -padx 5
    pack  $row2.script $row2.defScript  -side left -padx 3
}

proc panCkEvtScript { idx } {
   global panEvtScript
   if {[cequal $panEvtScript($idx) ""]} {
       panSetDefaultEvt $idx
   }
}

proc panSetDefaultEvt { idx } {
   global panEvtScript
   set name [getConfigInput $idx wdgName]
   set panEvtScript($idx) "panEvtDbUpdate $name %A %T %D %Q"
}

#----------------------------------------------------------------------------
# PROCEDURE : panEvtSetDefaultScript  -
#----------------------------------------------------------------------------
#
#proc panEvtSetDefaultScript { cv name newName } {
#   global panEvtScript
#   #
#   # Update default event script according to new widget name
#   #
#   if {[catch {set script [$cv.$name cget -evtScript]}] != 1} {
#      if {[lindex $script 0] == "panEvtDbUpdate"} {
#         set panEvtScript($idx) "panEvtDbUpdate $newName %A %T %D %Q"
#         $cv.$newName configure -evtScript $panEvtScript($idx)     
#      }
#   }
#}
#
#----------------------------------------------------------------------------
# PROCEDURE : displayEvtConfig -
#----------------------------------------------------------------------------

proc displayDbEvent { idx cv name } {
   global ckDbMode panEvtScript panEvtFilter

   set ckDbMode($idx)     [$cv.$name cget -dbMode]
   set panEvtScript($idx) [$cv.$name cget -evtScript]
   set panEvtFilter($idx) [string trim [$cv.$name cget -evtFilter] "\""]
}

#----------------------------------------------------------------------------
# PROCEDURE : configDbEvent -
#----------------------------------------------------------------------------

proc configDbEvent { idx cv name } {
   global ckDbMode panEvtScript panEvtFilter
   
   if {![info exists ckDbMode($idx)]} {
      puts "WARNING : variable ckDbMode($idx) not defined !!"
      return
   }

   $cv.$name configure -dbMode    $ckDbMode($idx) \
                       -evtScript $panEvtScript($idx) \
                       -evtFilter "\"$panEvtFilter($idx)\""   
}

#----------------------------------------------------------------------------
# PROCEDURE : checkDbVar -
#----------------------------------------------------------------------------

proc checkDbVar { idx w top } {
   global ckDbVar ckDbMode

   if {[winfo exists $top.r1] == 0 } { return }
   if {[winfo exists $top.r2] == 0 } { return }

   if {$ckDbVar($idx)} {
      $top.r1.poll   configure -state normal
      $top.r1.evt    configure -state normal
      $top.r1.filter enable 
      $top.r2.script configure -state normal -relief sunken
      set ckDbMode($idx)   [$w cget -dbMode]
   } else {
      $top.r1.poll   configure -state disabled
      $top.r1.evt    configure -state disabled
      $top.r1.filter disable
      $top.r2.script configure -state disabled -relief flat
      set ckDbMode($idx)   none
   }
}

#
# ___oOo___
