#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: configListValues.tcl,v 5.34 2005/09/26 12:44:29 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    08/01/97  created
#           20/04/98  Fixed bug in configStrAdd : elements were not inserted
#                     in the right position.
#
#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc configListValues { idx type } {
   global wdgConfig panSelectedColor panStrList

   set top [getWdgConfig $idx frameListValues]

   set myTop [frame $top.body -relief raised -bd 2]
   set row1  [frame $myTop.r1]
   set row2  [frame $myTop.r2]
   set row3  [frame $myTop.r3]

   set myFont "-Adobe-courier-medium-r-normal--12*-iso8859-1"

   label $myTop.title -text "Configure List Of Elements" \
                      -font "-Adobe-helvetica-bold-r-normal--14*-iso8859-1"

   set configList $myTop.configList ; setWdgConfig $idx configList $configList
   set myValue  $row2.myValue  ;      setWdgConfig $idx myValue    $myValue 
   set myString $row2.myString ;      setWdgConfig $idx myString   $myString
   set myPos    $row2.myPos ;         setWdgConfig $idx myPos      $myPos
   set wdgColor $row2.color ;         setWdgConfig $idx wdgColor   $wdgColor

   set panStrList($idx) {} ;# Initialize as dummy value

   set wdgConfig(listFormat) " %-8s %-30s %-s"

   if {[cequal $type UifOutputString]} {
       set  cfgLabel [format $wdgConfig(listFormat) Value "Output String" Color]
   } elseif {[cequal $type UifOutputIcon]} {
       set  cfgLabel [format $wdgConfig(listFormat) Value "List Of Icon Files" ""]
   } elseif {[cequal $type UifOptionButton]} {
       set  cfgLabel [format $wdgConfig(listFormat) Value "List Of Labels" ""]
   } else {
       set  cfgLabel "  Element List"
   }

   label $myTop.txt -text $cfgLabel -anchor w -fg White -bg darkOrchid -font $myFont

   UifListBox $configList -label "" -geometry 45x4 -font $myFont

   pack $myTop -padx 3 -fill x
   pack $myTop.title $myTop.txt $configList $row1 $row2 $row3 -padx 3 -fill x 

   entry  $myValue   -width 5  
   entry  $myString  -width 31
   entry  $myPos     -width 3

   if {[cequal $type UifOutputString]} {
       set  cfgLabel [format $wdgConfig(listFormat) Value "Output String" Color]
   } elseif {[cequal $type UifOutputIcon]} {
       set  cfgLabel [format $wdgConfig(listFormat) Value "Icon File" ""]
   } elseif {[cequal $type UifOptionButton]} {
       set  cfgLabel [format $wdgConfig(listFormat) Value "Label" ""]
   } else {
       set  cfgLabel "  Element List"
   }

   label $row1.txt1  -font $myFont  -text $cfgLabel -anchor w 
   pack  $row1.txt1 -side left  -fill x

   button $wdgColor -text "Color ..." -width 10 -command "configColor $idx" \
                    -font "-Adobe-courier-bold-r-normal--12*-iso8859-1"
   pack $myValue $myString $wdgColor $myPos -side left -padx 3

   #
   # Fill column c2
   #
   button  $row3.delete -text "Delete Item" -width 12 \
                        -command "configStrDel $idx"
   button  $row3.clear  -text "Delete All"  -width 12 \
                        -command "configStrDelAll $idx"

   pack $row3.delete $row3.clear -side left -expand 1 -pady 10

   #
   # Set Short Help Text
   #

   set configHelp [getWdgConfig $idx configHelp]

   UifShortHelp::add $configHelp $row3.delete \
	         {Use mouse to select item from list box and then delete it}

   UifShortHelp::add $configHelp $row3.clear \
                 {Delete all element in the list box}

   UifShortHelp::add $configHelp $myValue \
	         {Threshold value : type <RETURN> to add it to the list}

   UifShortHelp::add $configHelp $myString \
	         {String to display : type <RETURN> to add it to the list}

   #
   # Set specific bindings
   #

    if {[cequal $type "UifOutputString"]} {
	
	bind $myValue  <Return>  "configStrAdd $idx"
	bind $myString <Return>  "configStrAdd $idx"
	$configList setBind <1>  "configStrSelect $idx $myTop"
	$myPos configure -state disabled -relief flat
	
    } elseif { [cequal $type "UifOutputIcon"]} {
	    
	    
	bind $myValue  <Return>  "configStrAdd $idx"
	bind $myString <Return>  "configStrAdd $idx"
	$configList setBind <1>  "configStrSelect $idx $myTop"
	$myPos configure    -state disabled -relief flat
	$wdgColor configure -state disabled -relief flat
	set panSelectedColor "Black"

    } else {
	
	label  $row1.txt2  -font $myFont  -text Pos  -anchor w 
	pack $row1.txt2 -side right -padx 3 
	
	bind $myString <Return> "configListAddItem $idx $type"
	bind $myPos    <Return> "configListAddItem $idx $type"
	
	$configList setBind <1> "configListSelect $idx $type"
	$wdgColor configure -state disabled -relief flat
	
	if {[cequal $type UifOptionButton]} {
	    bind $myValue <Return> "configListAddItem $idx $type"
	} else {
	    $myValue configure -state disabled -relief flat
	}
    }
}


#------------------------------------------------------------------------------
# PROCEDURE :  Used to setup the current list configuration
#
# - configStrDel     , delete an  element from the list
# - configStrDelAll  , delete all elements from the list
# - configStrAdd     , add an element to the list
# - configStrSelect  , select and element
#
#------------------------------------------------------------------------------

proc configStrDelAll { idx } {
   global panStrList
   [getWdgConfig $idx configList]   deleteItem 0 end
   [getWdgConfig $idx myValue]  delete 0 end 
   [getWdgConfig $idx myString] delete 0 end 
   set panStrList($idx) {}
}

proc configStrDel { idx } {
   global panStrList

   set pos [[getWdgConfig $idx configList] getIndex]

   [getWdgConfig $idx configList] deleteItem $pos
   [getWdgConfig $idx  myValue]  delete 0 end 
   [getWdgConfig $idx  myString] delete 0 end 

   if {![lempty $panStrList($idx)] } {
      set panStrList($idx) [lreplace $panStrList($idx) $pos $pos]
   }
}

proc configStrSelect { idx top } {
    global  panSelectedColor panColor
    
    set tmp [[getWdgConfig $idx configList] getSelection] ; 
    set what [string trim $tmp "\{\}"]
    
    setConfigEntry $idx myValue  [lindex $what 0]
    setConfigEntry $idx myString [string trim [lindex $what 1] "\""]
    
    set panSelectedColor [lindex $what 2]
    
    # Here catch is used to cope with cases where it's not possible to 
    # configure the foreground color -e.g.- UifOutputIcon
    catch {[getWdgConfig $idx wdgColor] configure -foreground $panSelectedColor}

    set panColor $panSelectedColor
}

# This procedure is used to configure the list of elements for UifOutputString
# widgets : the element is automatically inserted according to its value, 
# such that the values are sorted in increasing order.

proc configStrAdd { idx } {
    global panSelectedColor panStrList wdgConfig
    
    set value      [getConfigInput $idx myValue]
    set string     [getConfigInput $idx myString]
    set configList [getWdgConfig $idx configList]
    
    set tmp [format $wdgConfig(listFormat) $value \"$string\" $panSelectedColor]

    set max    [llength $panStrList($idx)]
    set maxVal [lindex $panStrList($idx) [expr {$max - 1}]]
    set minVal [lindex $panStrList($idx) 0]
    
    set highVal     0
    set pos         end
    set addNewValue 1
    
    for { set i 0 } { $i < $max } { incr i } {

       if { $value >= $maxVal } {

	   if { $value == $maxVal } {
	       $configList deleteItem end ;# delete current position
	       set addNewValue 0 
	   }
	   set pos end ;# val == maximum , replace at the end
	   break
       } elseif { $value <= $minVal } {

	   if { $value == $minVal } {
	       $configList deleteItem 0 ;# delete current position
	       set addNewValue 0 
	   }
	   set pos 0  ;# val < minimum , add to beginning
	   break
       } else {

	   set lowVal  [lindex $panStrList($idx) $i]
	   set highVal [lindex $panStrList($idx) [expr {$i + 1}]]

	   if { $value == $lowVal } { 
	       $configList deleteItem $i ;# delete current position
	       set addNewValue 0 
	       set pos         $i        ;# add new value to current position
	       break
	   } elseif { $lowVal < $value && $value < $highVal } { 
	       set pos  [expr {$i + 1}]
	       break
	   }
       }
   }

   $configList addItem $pos $tmp 
   $configList component uifListBox see $pos

   if {$addNewValue} {
      set panStrList($idx) [linsert $panStrList($idx) $pos $value]
   }
}


proc configListAddItem { idx type } {
   global wdgConfig
   
   if { [set pos [getConfigInput $idx myPos]] == "" } { set pos "end" }

   if {[cequal $type UifOptionButton]} {

      if {[set value [getConfigInput $idx myValue]] == ""} { set value \"\" }
      set string [getConfigInput $idx myString]
      set tmp [format $wdgConfig(listFormat) $value \"$string\" ""]

   } else {
      set tmp [getConfigInput $idx myString]
   }

   [getWdgConfig $idx configList] addItem $pos $tmp
   [getWdgConfig $idx configList] component uifListBox see $pos
}

proc configListSelect { idx type } {

   set configList [getWdgConfig $idx configList]
   setConfigEntry $idx myPos [$configList getIndex]

   if {[cequal $type UifOptionButton]} {
#      set tmp [string trim [$configList getSelection] "\{\} "]
#      lassign [eval list $tmp ] value string

      lassign [$configList getSelection]  value string
      setConfigEntry $idx myValue  $value
      setConfigEntry $idx myString $string
   } else {
      setConfigEntry $idx myString [$configList getSelection]
   }
}

# ___oOo___
