#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: configMenuBar.tcl,v 5.34 2005/09/26 12:44:18 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ----------------------------------------------
# M.Bernini 24/05/94  created 
# M.Comin   05/07/94  Add comments to the code
#
# mcomin    27/02/96  Porting to TK4.0
#           21/03/97  Complete re-design
#
#
#************************************************************************
#   NAME
# 
#   SYNOPSIS
#  
#   DESCRIPTION
#
#   FILES
#    
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#------------------------------------------------------------------------
#

#------------------------------------------------------------------------------
# PROCEDURE : createMenuPanel -  Create the menuBar configuration panel.
#------------------------------------------------------------------------------

proc createMenuPanel { {menuName {.}}  } {
   global wdgConfig par menu doubleB1  mcHelp menuEdit topMenu menuType 

   if {[winfo exists .menuConfig]} {
      refreshMenuConfig

#      clearMenuConfig
#      displayMenu $wdgConfig(MENU) $par(ROOT_PANEL).topMenu.menu
#      enableMenuType               ;# Initialize menu-type configuration
      raise .menuConfig
      return
   }

   toplevel  .menuConfig;
   wm withdraw .menuConfig

   set wdgConfig(lblFont)  "-Adobe-courier-bold-r-normal--12*-iso8859-1"

   # Contains all widgets to navigate through the menus
   set top [frame .menuConfig.top -relief raised -bd 1];

   # Contains edit windows  
   set bot [frame .menuConfig.bot -relief raised -bd 2];

   # Contains buttons and short help
   set butFrame [frame .menuConfig.butFrame -relief ridge -bd 2]
   set sh       [frame $butFrame.sh]
   set actBut   [frame $butFrame.act]  
    
   pack $top $bot $butFrame -fill x -pady 5 -padx 3
   pack $sh $actBut         -fill x

   #
   #  Menu Navigation Widgets
   #

   frame $top.f1;  frame $top.f2;  frame $top.f3

   pack $top.f1 -fill x
   pack $top.f2 $top.f3 -fill x -pady 5 -padx 5

   UifEntry $top.f1.topMenu -label "Menu Path " -width 60\
            -labelFont $wdgConfig(lblFont) -variable topMenu

   $top.f1.topMenu disable

   label $top.f2.title1  -text "Menu Items "     -font $wdgConfig(lblFont)
   label $top.f2.title2  -text "Next Menu Level" -font $wdgConfig(lblFont)

   set wdgConfig(MENU)     $top.f3.topMenu
   set wdgConfig(SUB_MENU) $top.f3.subMenu

   UifListBox $wdgConfig(MENU)     -geometry 20x7
   UifListBox $wdgConfig(SUB_MENU) -geometry 20x7
   $wdgConfig(SUB_MENU) component uifListBox configure -relief flat

   pack $top.f1.topMenu -side left -padx 3
   pack $top.f2.title1  -side left 
   pack $top.f2.title2  -side right -padx 80
   pack $wdgConfig(MENU)     -side left  -fill x -padx 5 -expand 1
   pack $wdgConfig(SUB_MENU) -side right -fill x -padx 5

   #
   #  Menu Editing
   #

   frame $bot.f1
   frame $bot.f2
   frame $bot.f3 -relief ridge -bd 2   

   pack $bot.f1         -fill x -pady 10
   pack $bot.f2 $bot.f3 -fill x -padx 3 -pady 5

   set w $bot.f1
   label $w.l1  -text "Editing Mode : "

   set wdgConfig(rbINSPECT) $w.inspect
   set wdgConfig(rbADD)     $w.add 
   set wdgConfig(rbMODIFY)  $w.modify
   set wdgConfig(rbMOVE)    $w.move

   radiobutton $wdgConfig(rbINSPECT) -text "Show Configuration" -value show \
               -variable menuEdit -command menuConfigMode

   radiobutton $wdgConfig(rbADD) -text "Add"  -variable menuEdit \
               -value add -command menuConfigMode

   radiobutton $wdgConfig(rbMODIFY) -text "Modify" -value modify\
               -variable menuEdit -command menuConfigMode

   radiobutton $wdgConfig(rbMOVE) -text "Move Sub-Menu" -value move\
	       -variable menuEdit -comman "" -state disabled

   pack $w.l1 -side left
   pack $wdgConfig(rbINSPECT) $wdgConfig(rbADD) $wdgConfig(rbMODIFY) \
        $wdgConfig(rbMOVE) -side left -padx 10

   label $bot.f2.l1  -text "Menu Entry Configuration" \
                     -font "-Adobe-courier-bold-r-normal--14*-iso8859-1"

   pack $bot.f2.l1 -side left

   createEntryConfiguration $bot f3

   # Set Short Help

   set mcHelp $sh.help
   UifShortHelp $mcHelp ; pack $mcHelp -fill x -pady 5

   #
   #  Add frame with buttons for operations
   #

   set w1 [frame $actBut.f1]
   set w2 [frame $actBut.f2]
   set w3 [frame $actBut.f3]

   pack $w1 $w2 $w3 -fill x -pady 5

   set wdgConfig(addABOVE)   $w1.addAbove
   set wdgConfig(butMOVE_UP) $w1.butMoveUp
   set wdgConfig(butMODIFY)  $w1.butModify

   set wdgConfig(addBELOW)   $w2.addBelow
   set wdgConfig(butMOVE_DOWN) $w2.butMoveDown

   set wdgConfig(butDELETE)  $w1.butDelete
   set wdgConfig(butCLEAR)   $w3.butClear
   set wdgConfig(butREFRESH) $w3.butRefresh

   button $wdgConfig(addBELOW)  -text "Add Below Selection" -width 18 \
                                -command "addMenuBarItem 1"
   button $wdgConfig(addABOVE)  -text "Add Above Selection " -width 18 \
                                -command "addMenuBarItem 0"

   button $wdgConfig(butMOVE_UP)  -text "Move Up" -width 12 \
                                -command "moveMenuEntry -1" -state disabled
   button $wdgConfig(butMOVE_DOWN)  -text "Move Down" -width 12 \
                                -command "moveMenuEntry 1" -state disabled

   button $wdgConfig(butDELETE) -text " Delete Entry " -fg Red \
                                -command deleteMenuItem -width 12
   button $wdgConfig(butMODIFY) -text " Modify Configuration " -width 18 \
                                -command modifyMenuConfig

   button $wdgConfig(butCLEAR)  -text "Clear Fields" -width 12 \
                                -command clearMenuConfig

   button $wdgConfig(butREFRESH) -text "Refresh"  -width 18\
                                 -command refreshMenuConfig -width 18

   button $w3.cancel  -text "Cancel"  -command "destroy .menuConfig" -width 12

   pack $wdgConfig(addABOVE) $wdgConfig(butMOVE_UP) $wdgConfig(butMODIFY) \
        -side left -padx 10

   pack $wdgConfig(addBELOW) $wdgConfig(butMOVE_DOWN) -side left -padx 10

   pack $wdgConfig(butDELETE) -side right -padx 10
   pack $wdgConfig(butREFRESH) $wdgConfig(butCLEAR) -side left -padx 10
   pack $w3.cancel            -side right -padx 10

   #
   # Set Bindings
   #

   $wdgConfig(MENU)     setBind <Double-Button-1> displayNewMenu
   $wdgConfig(MENU)     setBind <1>               displaySelMenu
   $wdgConfig(SUB_MENU) setBind <1> "break"

   wm title     .menuConfig  "Menu Configuration Panel"
   wm resizable .menuConfig  0 0
   wm deiconify .menuConfig

   set tmp [wm protocol .menuConfig WM_DELETE_WINDOW]
   wm protocol .menuConfig WM_DELETE_WINDOW "$tmp ; destroy .menuConfig"

   tkwait visibility .menuConfig

   initMenuConfig  $mcHelp    ;# Initialize the panel
}

proc refreshMenuConfig {} {
   global par wdgConfig
   clearMenuConfig
   displayMenu $wdgConfig(MENU) $par(ROOT_PANEL).topMenu.menu
   enableMenuType               ;# Initialize menu-type configuration
   $wdgConfig(butREFRESH) configure -state disabled
}


proc initMenuConfig { sh } {
   global par wdgConfig menuEdit doubleB1

   # Configure short help for the config. panel 

   set tmp "Components of the menu under editing"
   append tmp " : click <B1> on an item to see its configuration" 

   UifShortHelp::add $sh $wdgConfig(MENU) $tmp

   UifShortHelp::add $sh $wdgConfig(SUB_MENU) \
       "Shows what contains the next menu level."

   UifShortHelp::add $sh $wdgConfig(rbINSPECT) \
       "Set the panel to show the current configuration of each 'Menu Item' "

   UifShortHelp::add $sh $wdgConfig(rbADD) \
       "Set the panel to add new elements to the Menu"

   UifShortHelp::add $sh $wdgConfig(rbMODIFY) \
       "Set the panel to modify the configuration of existing 'Menu Items' "

   UifShortHelp::add $sh $wdgConfig(butREFRESH) \
       "Enabled when the current menuBar configuration panel needs to be updated"

   #
   # Add help for the 'Menu Entry Configuration"
   #

   UifShortHelp::add $sh $wdgConfig(mnNAME) \
       "Name of the widget : applies only for Menu and Menubutton"

   UifShortHelp::add $sh $wdgConfig(mnULINE) \
       "Enter which character in the label to use as 'accelerator key' : 0 means none"

   UifShortHelp::add $sh $wdgConfig(mnVAR) "Variable associated to the widget"

   UifShortHelp::add $sh $wdgConfig(mnCMD) \
	   "The command is by default enclosed in '{}' "

   #
   # Add help for the buttons at the bottom
   #

   set tmp "CLICK on <B1> to SELECT Position on 'Menu Items'"

   set tmp1 "$tmp : ADD new item BELOW selected item"
   UifShortHelp::add $sh $wdgConfig(addBELOW) $tmp1

   set tmp1 "$tmp : ADD new item ABOVE selected item"
   UifShortHelp::add $sh $wdgConfig(addABOVE) $tmp1

   set tmp1 "$tmp : REPLACE current configuration"
   UifShortHelp::add $sh $wdgConfig(butMODIFY) $tmp1

   set tmp1 "$tmp : DELETE element"
   UifShortHelp::add $sh $wdgConfig(butDELETE) $tmp1

   UifShortHelp::add $sh $wdgConfig(butCLEAR) \
        "Clear entry fields in 'Menu Entry Configuration'"

   #
   #  Initialize the contents of the panel
   #
  
   set doubleB1 0
   set menuEdit show 
   menuConfigMode     ;# Configure button at the bottom
   refreshMenuConfig  ;# Initialize panel configuration contents
}


proc createEntryConfiguration { top f } {
   global wdgConfig

   # Create frames of sub-panel

   set top $top.$f

   for {set i 1} {$i < 8} { incr i} {
       set w ${top}.c${i} ; frame $w ; pack  $w -fill x -pady 3
   }

   set w $top.c2

   set wdgConfig(frameMENU_TYPE) $w

   radiobutton $w.menuBut -text "Menubutton"  -variable menuType \
               -value "Menubutton" -command "setEditState" \
               -font $wdgConfig(lblFont)

   radiobutton $w.submenu -text "Menu"  -variable menuType -value "cascade" \
               -command "setEditState" -font $wdgConfig(lblFont)
                              
   radiobutton $w.sep -text "Separator" -variable menuType -value "separator"\
               -command "setEditState" -font $wdgConfig(lblFont)
                              
   radiobutton $w.cb -text "checkButton" -variable menuType \
               -value "checkbutton" -command "setEditState" \
               -font $wdgConfig(lblFont)
                              
   radiobutton $w.rb   -text  "radioButton" -variable menuType \
               -value "radiobutton"  -command "setEditState"   \
               -font $wdgConfig(lblFont)
                              
   radiobutton $w.cmd  -text "Command" -variable menuType -value "command" \
                -command "setEditState" -font $wdgConfig(lblFont)

   pack $w.menuBut $w.submenu $w.sep $w.cb $w.rb $w.cmd \
        -side left -padx 5 -pady 10

   set wdgConfig(mnNAME)  $top.c3.mnName
   set wdgConfig(mnLABEL) $top.c4.mnLabel
   set wdgConfig(mnULINE) $top.c4.mnUline
   set wdgConfig(mnVAR)   $top.c5.mnVar 
   set wdgConfig(mnVAL)   $top.c5.mnVal
   set wdgConfig(mnCMD)   $top.c6.mnCmd
   set wdgConfig(mnSH)    $top.c7.mnHelp

   UifEntry $wdgConfig(mnNAME) -label "Widget Name" -width 25 \
            -labelWidth 15 -labelFont $wdgConfig(lblFont) -variable itemName

   UifEntry $wdgConfig(mnLABEL) -label "Label" -width 25 -labelWidth 15 \
            -labelFont $wdgConfig(lblFont) -variable itemLabel

   UifEntry $wdgConfig(mnULINE) -label "Underline" -width 3 \
            -labelWidth 12 -labelFont $wdgConfig(lblFont) -variable itemUline

   UifEntry $wdgConfig(mnVAR) -label "Variable" -width 25 -labelWidth 15 \
            -labelFont $wdgConfig(lblFont) -variable itemVar

   UifEntry $wdgConfig(mnVAL) -label "Value" -width 17 -labelWidth 12 \
            -labelFont $wdgConfig(lblFont) -variable itemVal

   UifEntry $wdgConfig(mnCMD) -label "Command" -width 55 -labelWidth 15 \
            -labelFont $wdgConfig(lblFont) -variable itemCmd

   UifEntry $wdgConfig(mnSH) -label "Short Help" -width 55 -labelWidth 15 \
            -labelFont $wdgConfig(lblFont) -variable itemHelp

   pack $wdgConfig(mnNAME) -side left -padx 5
   pack $wdgConfig(mnLABEL) $wdgConfig(mnULINE) -side left -padx 5
   pack $wdgConfig(mnVAR) $wdgConfig(mnVAL)     -side left -padx 5
   pack $wdgConfig(mnCMD) -side left -padx 5
   pack $wdgConfig(mnSH)  -side left -padx 5
}

#------------------------------------------------------------------------------
# PROCEDURE : menuConfigMode - 
#------------------------------------------------------------------------------

proc menuConfigMode {} {
   global wdgConfig menuEdit

   # Set by default all disabled

   $wdgConfig(butDELETE) configure -state disabled
   $wdgConfig(butCLEAR)  configure -state disabled
   $wdgConfig(addBELOW)  configure -state disabled
   $wdgConfig(addABOVE)  configure -state disabled
   $wdgConfig(butMODIFY) configure -state disabled
   $wdgConfig(butMOVE_UP)   configure -state disabled
   $wdgConfig(butMOVE_DOWN) configure -state disabled

   if {$menuEdit != "show"} {
      $wdgConfig(butDELETE) configure -state normal
      $wdgConfig(butCLEAR)  configure -state normal
   }

   if {$menuEdit == "add"} {
      $wdgConfig(addBELOW)  configure -state normal
      $wdgConfig(addABOVE)  configure -state normal
      $wdgConfig(butMODIFY) configure -state disabled
   } elseif {$menuEdit == "modify"} {
      $wdgConfig(butMODIFY) configure -state normal
      $wdgConfig(butMOVE_UP)   configure -state normal
      $wdgConfig(butMOVE_DOWN) configure -state normal
   }

   enableMenuType 
}

#------------------------------------------------------------------------------
# PROCEDURE : enableMenuType -
#------------------------------------------------------------------------------

proc enableMenuType {} {
   global wdgConfig topMenu menuEdit

   set w $wdgConfig(frameMENU_TYPE)

   if {$menuEdit == "show" || $menuEdit == "modify"} {

      # Disable radiobuttons to avoid the user modify
      # the current configuration

      $w.menuBut configure -state disabled
      $w.submenu configure -state disabled
      $w.sep     configure -state disabled
      $w.cb      configure -state disabled
      $w.rb      configure -state disabled
      $w.cmd     configure -state disabled

   } else {

      if {[winfo class $topMenu] != "Frame"} {
         $w.menuBut configure -state disabled
         $w.submenu configure -state normal
         $w.sep     configure -state normal
         $w.cb      configure -state normal
         $w.rb      configure -state normal
         $w.cmd     configure -state normal
      } else {
         $w.menuBut configure -state normal
         $w.submenu configure -state disabled
         $w.sep     configure -state disabled
         $w.cb      configure -state disabled
         $w.rb      configure -state disabled
         $w.cmd     configure -state disabled
      }
  }
}

#------------------------------------------------------------------------------
# PROCEDURE : deleteMenuItem - Delete Entry from Menu
#------------------------------------------------------------------------------

proc deleteMenuItem { {idx ""} } {
   global par wdgConfig topMenu menu m_name menuHelp menuType

   # get currently selected entry

   if {$idx == ""} {
      if {[set idx [$wdgConfig(MENU) getIndex]] == "" } { return }
   }

   incr par(SAVE_FLAG)

   if { ! [cequal [winfo class $topMenu] Frame] } {

      if {[cequal $menuType cascade]} {
         set menuPath [$topMenu entrycget $idx -menu]
         destroy $menuPath ;# Destroy menu widget associated with the entry
      }

      $topMenu delete $idx  ;# Delete an entry in a cascade menu

      # Delete short help associated to the entry
      if {[info exists menuHelp($topMenu)]} {
         set menuHelp($topMenu) [lreplace $menuHelp($topMenu) $idx $idx]
      }

   } else {

      # Delete a menuButton
      set wdgName  [lindex $menu($idx) $m_name]
      set max      [expr {[array size menu] - 1}]

      for {set i $idx } { $i < $max } { incr i } {
          set menu($i) $menu([expr {$i + 1}])
      }

      unset menu($max)
      destroy $topMenu.$wdgName
   }

   displayMenu $wdgConfig(MENU) $topMenu
   return
}

#------------------------------------------------------------------------------
# PROCEDURE : modifyMenuConfig  - Modify the configuration of an existing 
#                                 menu entry
#------------------------------------------------------------------------------

proc modifyMenuConfig {} {
   global par wdgConfig mcHelp topMenu menu menuType shArea menuEdit
   global itemName itemLabel itemUline itemVal itemCmd itemCmd itemVar itemHelp

   if {$menuType == "separator" || $menuType == "tearoff" } { return }

   incr par(SAVE_FLAG)

   #  Get user's input parameters and check conditions to abort the operation

   if {[set idx [$wdgConfig(MENU) getIndex]] == "" } {

      if {[info exists wdgConfig(LAST_MENU_IDX)] == 0} {
         $mcHelp displayText "WARNING : Select insertion position"
         return
      } else {
         set idx $wdgConfig(LAST_MENU_IDX)
      }
   }

   # Check correctness of common parameters

   if {$itemLabel == ""} { return }
   if {$itemUline == ""} { set itemUline 0}

   if {$menuType == "Menubutton"} {

      $topMenu.$itemName configure -text "$itemLabel" -underline $itemUline

      set menu($idx) [list $itemLabel $itemUline $itemName $itemHelp]

      # Define binding for short help with the new value

      if {[winfo exists $shArea] } {
         bindMenubuttonHelp $topMenu.$itemName $itemHelp $shArea
      }

      displayMenu $wdgConfig(MENU) $topMenu
      return
   }

   # Modify a normal menu entry  

   $topMenu entryconfigure $idx -label $itemLabel

   if {$menuType == "cascade"} {

      $topMenu entryconfigure $idx -underline $itemUline

   } elseif { $menuType == "radiobutton" } {

      $topMenu entryconfigure $idx -command $itemCmd -value $itemVal \
               -variable $itemVar -underline $itemUline

   } elseif { $menuType == "checkbutton" } {

       $topMenu entryconfigure $idx -command $itemCmd -variable $itemVar\
                -underline $itemUline

   } elseif { $menuType == "command" } {

       $topMenu entryconfigure $idx -command $itemCmd -underline $itemUline
   }

   addMenuHelp $topMenu $idx $menuEdit
   displayMenu $wdgConfig(MENU) $topMenu
}

#------------------------------------------------------------------------------
# PROCEDURE : addMenuItem - Add a menu Item
#------------------------------------------------------------------------------

proc addMenuBarItem { pos } {
   global par wdgConfig mcHelp topMenu menu shArea
   global itemName itemLabel itemUline itemVal itemCmd itemCmd itemVar itemHelp

   #  Get user's input parameters and check conditions to abort the operation

   if {[set idx [$wdgConfig(MENU) getIndex]] == "" } {
      $mcHelp displayText "WARNING : Select insertion position"
      return
   }

   incr par(SAVE_FLAG)
   incr idx $pos ; set rootIdx $idx

   if {[winfo class $topMenu] != "Frame"} {
      menuAddEntry $topMenu $idx
      return
   }

   # The Menubar top level is a frame and its components are 'Menubutton'

   if {$itemLabel == ""} { return }
   if {$itemUline == ""} { set itemUline 0}

   set itemName [string tolower $itemName]

   set mb [addMenuButton $topMenu $itemName $itemLabel $itemUline ]  

   if {$mb == "" } {
      set msg "CANNOT CREATE MENU\nChange widget name"
      tk_dialog .dialog "Dialog Box" $msg info 0 OK
      return
   }

   set max [array size menu]

    for {set i [expr {$max - 1}]} { $i >= $idx } { incr i -1} {
	set menu([expr {$i + 1}]) $menu($i)
   }

   set menu($idx) [list $itemLabel $itemUline $itemName $itemHelp]
   set mb         [addMenuButton $topMenu $itemName $itemLabel $itemUline]

   # Define binding for short help with the new value

   if {[winfo exists $shArea] } {
      bindMenubuttonHelp $topMenu.$itemName $itemHelp $shArea
   }

   if {$rootIdx != 0 } { incr rootIdx -1 }

   set w $topMenu.[lindex $menu($rootIdx) 2]

   pack $topMenu.$itemName -after $w -side left -padx 5

   displayMenu $wdgConfig(MENU) $topMenu
}

#------------------------------------------------------------------------------
# PROCEDURE : moveMenuEntry - Move a menu entry up/down one position
#------------------------------------------------------------------------------

proc moveMenuEntry { pos } {
   global menuEdit par wdgConfig topMenu mcHelp itemName menuType

   # Check if this is really a menu entry.

   if {[cequal [winfo class $topMenu] Frame] } { return }

   #  Get user's input parameters and check conditions to abort the operation

   if {[set idx [$wdgConfig(MENU) getIndex]] == "" } {
      $mcHelp displayText "WARNING : Select Menu Element"
      return
   }

   # Check if we reached the top position

   if {$idx == 1 && $pos < 0 } { return } 

   incr par(SAVE_FLAG)
 
   # Copy the links to the underlying sub-tree

   if {[cequal $menuType cascade]} {
      set menuPath [$topMenu entrycget $idx -menu]
      copyCascadeMenu $menuPath
   }

   deleteMenuItem $idx ;# Delete element in current position

    menuAddEntry $topMenu [expr {$idx + $pos}]
    $wdgConfig(MENU) setSelection [expr {$idx + $pos}]

   # Restore the links to the underlying sub-tree

   if {[cequal $menuType cascade]} {
      restoreCascadeMenu $menuPath
   }
}


#-----------------------------------------------------------------------------
# PROCEDURE : copyCascadeMenu - Records the configuration of a cascade menu
#-----------------------------------------------------------------------------

proc copyCascadeMenu { w } {
   global cascadeConfig cascadeMenuHelp menuHelp

   if {[info exists cascadeConfig]}   { unset cascadeConfig }
   if {[info exists cascadeMenuHelp]} { unset cascadeMenuHelp }

   set max [$w index end]
   for {set i 0} {$i <= $max} { incr i } {
      set cascadeConfig($i) "[$w type $i] [$w entryconfig $i]"
   }

   if {[info exists menuHelp($w)]} { set cascadeMenuHelp $menuHelp($w) }
}

#-----------------------------------------------------------------------------
# PROCEDURE : restoreCascadeMenu - Restore the configuration of a 
#                                  cascade menu in an existing one
#-----------------------------------------------------------------------------

proc restoreCascadeMenu { w } {
   global cascadeConfig cascadeMenuHelp shArea menuHelp

   set max [array names cascadeConfig]

   for {set pos 1} {$pos <= $max} { incr pos } {
       set menuType [lindex $cascadeConfig($pos) 0]

       if {[cequal $menuType separator] } { 
          $w insert $pos separator ; continue
       }

       # Create dummy entry
       switch $menuType {
         Menu -
         cascade { set mb [insertCascadeMenu $pos $w itemName itemLabel 0] }

         command { insertMenuCmd $pos $w itemLabel 0 "" }
         checkbutton { insertMenuCk $pos $w itemLabel 0 "" itemVar }
         radiobutton { insertMenuRb $pos $w itemLabel 0 "" itemVar 0}
         default     { set do nothing }
       }

       # Configure dummy entry with the proper original values

       foreach item $cascadeConfig($pos) {
	  if {[set value [lindex $item 4]] != ""} {
             $w entryconfigure $pos [lindex $item 0] $value
          }
       }
   }

   # Restore Short Help

   if {[info exists cascadeMenuHelp]} {
       set menuHelp($w) $cascadeMenuHelp
       bindMenuHelp $w $shArea
   }
}


#------------------------------------------------------------------------------
# PROCEDURE : menuAddEntry - Add an entry to menu
#------------------------------------------------------------------------------

proc menuAddEntry { w pos } {
   global wdgConfig mcHelp menuType menuEdit
   global itemName itemLabel itemUline itemVal itemCmd itemCmd itemVar

   # To add a new element :
   # - Get the name of the menu where to create it
   # - Add new element to the menu
   # - Re- display menu contents

   if {[cequal $menuType separator] } {
      $w insert $pos separator
   } else {

       if {$itemLabel == ""} { return }
       if {$itemUline == ""} { set itemUline 0}

       if {[cequal $menuType Menu] || [cequal $menuType cascade] } {

          set mb [insertCascadeMenu $pos $w $itemName $itemLabel $itemUline]

          if {$mb == "" } {
             set msg "CANNOT CREATE MENU\nChange widget name"
             tk_dialog .dialog "Dialog Box" $msg info 0 OK
             return
          }

       } elseif {[cequal $menuType command]} {

          insertMenuCmd $pos $w $itemLabel $itemUline $itemCmd

       } elseif {[cequal $menuType checkbutton]} {

          insertMenuCk $pos $w $itemLabel $itemUline $itemCmd $itemVar

       } elseif {[cequal $menuType radiobutton]} {

          insertMenuRb $pos $w $itemLabel $itemUline $itemCmd $itemVar $itemVal
       } else {
          puts "DBG> menuAddEntry .. not recognized type $menuType"
       }
   }

   addMenuHelp $w $pos add
   displayMenu $wdgConfig(MENU) $w
}


#------------------------------------------------------------------------------
# PROCEDURE : addMenuHelp  - 
#------------------------------------------------------------------------------

proc addMenuHelp { w pos what } {
   global menuHelp menuType itemHelp  shArea

   if {$menuType == "separator" || $menuType == "tearoff"} { return }

   if {[info exists menuHelp($w)] == 0} {
       for {set i 0 } {$i <= [$w index end]} { incr i} {
          lappend menuHelp($w) "" ;# Set dummy structure
       }
   }

   if {$what == "add"} {
      set menuHelp($w) [linsert $menuHelp($w) $pos $itemHelp]
   } else {
      set menuHelp($w) [lreplace $menuHelp($w) $pos $pos $itemHelp]
   }

   bindMenuHelp $w $shArea
#   puts "New $pos -- $menuHelp($w)"
}


#------------------------------------------------------------------------------
# PROCEDURE : setEditState  - Enable/Disable proper config. parameters 
#                             according to the type of item
#------------------------------------------------------------------------------

proc setEditState { } {
   global  wdgConfig menuType menuEdit
    
   #
   # Change widget status according to the item type
   #     
 
   $wdgConfig(mnNAME)  disable ; $wdgConfig(mnLABEL) disable
   $wdgConfig(mnULINE) disable ; $wdgConfig(mnVAR)   disable
   $wdgConfig(mnVAL)   disable ; $wdgConfig(mnCMD)   disable
   $wdgConfig(mnSH)    disable ;

   if { $menuType == "separator" || $menuType == "tearoff" } { return }

   $wdgConfig(mnLABEL) enable
   $wdgConfig(mnSH)    enable
   $wdgConfig(mnULINE) enable

   if { $menuType == "cascade" || $menuType == "Menubutton" } {
      if {$menuEdit != "modify"} { $wdgConfig(mnNAME)  enable }
      return
   } 

   $wdgConfig(mnCMD)   enable

   if { $menuType == "command" } { return }

   $wdgConfig(mnVAR) enable

   if { $menuType == "checkbutton" } { return }

   $wdgConfig(mnVAL) enable

}



#------------------------------------------------------------------------------
# PROCEDURE : clearMenuConfig - Clear the Menu Configuration panel
#------------------------------------------------------------------------------

proc clearMenuConfig { } {
   global itemName itemLabel itemUline itemVal itemCmd itemCmd itemVar itemHelp

   set itemName "" ; set itemLabel "" ; set itemUline 0
   set itemVal  "" ; set itemCmd   "" ; set itemCmd ""
   set itemVar  "" ; set itemHelp  ""
}


#------------------------------------------------------------------------------
# PROCEDURE : showMenuConfig - Show Menu configuration
#------------------------------------------------------------------------------

proc showMenuConfig { menuName idx } {
   global menuType menuEdit menuHelp menu m_help
   global itemName itemLabel itemUline itemVal itemVar itemCmd itemHelp

   if {$menuEdit == "add"} { return }

   clearMenuConfig  ;# Clear Current Input Fields 

   if {[winfo class $menuName] == "Menubutton"} {
      set menuType Menubutton
   } else {
      set menuType [$menuName type $idx]
   }

#   puts "DBG> showMenuConfig $menuName $idx $menuType"

   switch $menuType {
      cascade {
         set itemUline [$menuName entrycget $idx -underline]
         set path      [$menuName entrycget $idx -menu]
         set itemName  [winfo name $path] 
      }

      Menubutton {
         set itemUline [$menuName cget -underline]
         set itemName  [winfo name $menuName]
         set itemLabel [$menuName cget -text]
      }

      command {
         set itemCmd [$menuName entrycget $idx -command]
      }

      radiobutton {
         set itemCmd [$menuName entrycget $idx -command]
         set itemVar [$menuName entrycget $idx -variable]
         set itemVal [$menuName entrycget $idx -value]
      }

      checkbutton {      
         set itemCmd [$menuName entrycget $idx -command ]
         set itemVar [$menuName entrycget $idx -variable]
      }

   } ;# End switch ..

   # Common Parameters
 
   if { $menuType != "Menubutton" && $menuType != "separator" && \
        $menuType != "tearoff" } {
      set itemLabel [$menuName entrycget $idx -label]   
   }   
  
   # Get short help

   set itemHelp ""

   if {$menuType == "Menubutton"} {
       set itemHelp [lindex $menu($idx) $m_help]
   } else {
      if {[info exists menuHelp($menuName)]} {
         set itemHelp [lindex $menuHelp($menuName) $idx]
      }
   }

   setEditState ;  # Change widget status according to the item type
}


#------------------------------------------------------------------------------
# PROCEDURE : displayMenu - Display the content of a menu in the listBox
#
# Parameter 'parentMenu' must be the full path of a widget of type 'Menubutton'
# The procedure will find the name of the associated menu which is given
# by the '-menu' option.
#
#------------------------------------------------------------------------------

proc displayMenu { w parentMenu } {
   global wdgConfig topMenu menu m_label

   if {[winfo exists $parentMenu] == 0 } { return }

   set menuType [winfo class $parentMenu]

   switch $menuType {
       Menubutton  { set menuName [$parentMenu cget -menu] }
       Menu        { set menuName $parentMenu }
       default     {
                   # Get labels for menuButton
                   foreach i [lsort [array names menu]] {
                      lappend menuList [lindex $menu($i) $m_label]
                   }
                   displayMenuBar $w $menuList ; return 
                   }
   }

   $w                    deleteItem 0 end  ;# Clear Menu
   $wdgConfig(SUB_MENU)  deleteItem 0 end  ;# Clear Menu Entry

   set numnItems  [$menuName index end]    ;# Get Number of items in menu

   if {$w != "$wdgConfig(SUB_MENU)"} {
       # Add virtual element to navigate through menus
       $w addItem end ".."

       if { $menuType == "Menubutton"} {
          set topMenu  [$parentMenu cget -menu]
       } else {
          set topMenu  $parentMenu
       }
   }

   for {set i 1} { $i <= $numnItems } {incr i} {
       set mnType  [$menuName type $i]

       if {$mnType == "separator"} {
          $w addItem end "----------"  ;# Separator     
       } else {
          set mnLabel [$menuName entrycget $i -label]

          # Add " >" if the menu entry leads to a sub-menu
	  if {$mnType == "cascade"} { append mnLabel " >" }
              
          $w addItem end $mnLabel
       }
   }; # end of for ..          
}


#------------------------------------------------------------------------------
# PROCEDURE : displayMenuBar - Display the MenuBar in the listBox
#------------------------------------------------------------------------------

proc displayMenuBar { w rootList } {
   global par wdgConfig topMenu 
      
   $w                    deleteItem 0 end ;# Clear Menu
   $wdgConfig(SUB_MENU)  deleteItem 0 end ;# Clear Menu Entry

   set topMenu $par(ROOT_PANEL).topMenu.menu

   foreach item $rootList {
      $w addItem end "$item >"
   }        
}


#------------------------------------------------------------------------------
# PROCEDURE : displaySelMenu - 
#------------------------------------------------------------------------------

proc displaySelMenu { } {
   global wdgConfig doubleB1 topMenu  menu m_name

   if {$doubleB1 == 2} { set doubleB1 1 ; return }

   # Return if no elements are selected
   if {[set idx [$wdgConfig(MENU) getIndex]] == ""} { return }

   set wdgConfig(LAST_MENU_IDX) $idx
   set classType [winfo class $topMenu]

   if {$classType != "Menubutton" && $classType != "Menu" } {

      # At the top, the menubar is formed by a frame with sequence of
      # menus

      set tmp [string tolower [lindex $menu($idx) $m_name]]

      if {[cequal $tmp ""]} {
         puts "DBG > wrong index $idx"
         puts "Current menu configuration is :  $menu($idx)"
         puts "Send problem report to mcomin@eso.org with error stack and this description"
      } else {
         displayMenu $wdgConfig(SUB_MENU) $topMenu.$tmp
         showMenuConfig $topMenu.$tmp $idx
      }

   } else {

      if { [$topMenu type $idx] == "cascade" } {
         set subMenu [$topMenu entrycget $idx -menu]
         displayMenu $wdgConfig(SUB_MENU) $subMenu
      } else {
         $wdgConfig(SUB_MENU) deleteItem  0 end
      }

      showMenuConfig $topMenu $idx
   }

}


#------------------------------------------------------------------------------
# PROCEDURE : displayNewMenu - 
#------------------------------------------------------------------------------

proc displayNewMenu {} {
   global wdgConfig doubleB1 topMenu menu m_name

   set doubleB1 2

   # Return if no elements are selected
   if {[set idx [$wdgConfig(MENU) getIndex]] == ""} {
      return
   }
   
   if {[$wdgConfig(MENU) getSelection] == ".."} {

      # The virtual entry '..' tells the browser to go one level up
      set newMenu [winfo parent $topMenu]
     
      # For Menubutton widgets we need a double step back
      if {[winfo class $newMenu] == "Menubutton"} { 
         set newMenu [winfo parent $newMenu] 
      }

   } else {

      # Check if we are the top of the menubar
     
      if {[winfo class $topMenu] == "Frame"} {

         set tmp [string tolower [lindex $menu($idx) $m_name]]
         set newMenu "$topMenu.$tmp"

      } else {

         # Returns if the menu entry does not lead to a sub-menu
         if {[$topMenu type $idx] != "cascade"} { return }

         set newMenu [$topMenu entrycget $idx -menu]
      }
   }
#   puts "DBG> displayNewMenu $newMenu"

   displayMenu $wdgConfig(MENU) $newMenu
   enableMenuType
}

