#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: configOutputArray.tcl,v 5.34 2005/09/26 12:44:30 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin  05/01/98  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc uifOutputArrayPanel { idx top type } {
   global  wdgConfig

   addFormatAndUnits $idx $type
   configAnchor $idx

   # Add array size in the line of the format

   set top [getWdgConfig $idx frameArray]

   UifEntry $top.arraySize -label " Array Size" -width 4\
            -labelWidth $wdgConfig(lblWidth) -labelFont $wdgConfig(lblFont)\
            -variable wdgConfig${idx}(arraySize)

   UifEntry $top.arrayPad -label " Padding" -width 3\
            -labelWidth $wdgConfig(lblWidth) -labelFont $wdgConfig(lblFont)\
            -variable wdgConfig${idx}(arrayPad)

   pack $top.arraySize $top.arrayPad -side left
}

#-----------------------------------------------------------------------------
# PROCEDURE : outputLedButton - Updates the configuration panel according 
#                               to the current UifButton Class configuration
#-----------------------------------------------------------------------------

proc displayOutputArray { idx cv top name } {
   global wdgConfig ckOrientation ckFrame panOutputAnchor

   set panOutputAnchor($idx) [$cv.$name cget -anchor]

   setWdgConfig $idx arraySize [$cv.$name cget -size]
   setWdgConfig $idx arrayPad  [$cv.$name cget -padding]

   set ckOrientation($idx) [$cv.$name cget -orient]

   set ckFrame($idx)         [$cv.$name cget -frame]
   set panOutputAnchor($idx) [$cv.$name cget -anchor]

   set panSelectedFont    [$cv.$name cget -font]
   setWdgConfig $idx font $panSelectedFont

   set panSelectedColor    [$cv.$name cget -color]
   setWdgConfig $idx color $panSelectedColor
   [getWdgConfig $idx wdgColor] configure -fg $panSelectedColor

   setConfigEntry $idx wdgFormat  [$cv.$name cget -format]
}


#-----------------------------------------------------------------------------
# PROCEDURE : configOutputLed - Updates the data structures describing the
#                               configuration of the UifButton Class
#-----------------------------------------------------------------------------

proc configOutputArray { idx cv type name } {
   global wdgConfig ckOrientation ckFrame panOutputAnchor

   if {$ckFrame($idx) == 0} {    
      set tmp  [$cv.$name cget -variable ] ;# In case of no frame this helps
      uplevel #0 set $tmp 0                ;# identify the widget position
   }

   $cv.$name configure -color  [getWdgConfig $idx color] \
                       -font   [getWdgConfig $idx font] \
                       -anchor $panOutputAnchor($idx) -frame $ckFrame($idx)\
                       -format [getConfigInput $idx wdgFormat]\
                       -size   [getWdgConfig $idx arraySize]\
                       -orient $ckOrientation($idx) \
                       -padding [getWdgConfig $idx arrayPad] 
}

#
# ___oOo___
