#
# E.S.O. - VLT project
#
# "@(#) $Id: configOutputIcon.tcl,v 5.34 2005/09/26 12:44:31 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ----------------------------------------------
# M.COMIN   27/04/95  created 
# mcomin    27/02/96  Porting to TK4.0
#           25/06/97  Add options -itemValue -selectMode
#

#-----------------------------------------------------------------------------
# PROCEDURE : uifOutputIconPanel -  Creates config. panel for UifOutputIcon
#------------------------------------------------------------------------------

proc uifOutputIconPanel { idx top type } {
   global panSelectMode wdgConfig

   configListValues $idx $type ;# Create sub-panel to configure a list
}


#------------------------------------------------------------------------------
# PROCEDURE : configUifOptButton - Updates the data structures describing 
#                                  the widget configuration 
#------------------------------------------------------------------------------

proc configOutputIcon { idx cv top name } {
    global wdgConfig panSelectMode panStrList

    set panStrList($idx) [$cv.$name cget -listValues]
    set configList       [getWdgConfig $idx configList]
    set numbItems        [$configList getSize]

    set iconList  {}
    set listValue {}
    
    for { set i 0 } {$i < $numbItems} { incr i } {
	lassign [$configList getItem $i] value iconFile
	lappend iconList  $iconFile
	lappend listValue $value
    }
    
    $cv.$name configure -listValues $listValue -listPictures $iconList
}


#------------------------------------------------------------------------------
# PROCEDURE : displayUifOptButton - Updates the configuration panel according
#                                   to the current Class configuration
#------------------------------------------------------------------------------

proc displayUifOutputIcon { idx cv top name } {
    global wdgConfig panSelectMode ckFrame panStrList
    
    set l1 [$cv.$name cget -listPictures]
    set l2 [$cv.$name cget -listValues]
    
    set panStrList($idx) $l2
    set ckFrame($idx) [$cv.$name cget -frame]
    
    set len [llength $l1]
    
    for {set pos 0} {$pos < $len} { incr pos} {
	if {[set value [lindex $l2 $pos]] == ""} { set value \"\" }
	set tmp [format $wdgConfig(listFormat) $value \"[lindex $l1 $pos]\" ""]
	[getWdgConfig $idx configList] addItem $pos $tmp
    }
}
