#
# E.S.O. - VLT project
#
# "@(#) $Id: configOutputString.tcl,v 5.34 2005/09/26 12:44:24 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ----------------------------------------------
# M.COMIN   22/03/95  created 
# M.COMIN   06/04/95  Strings can be formed by several words
# M.COMIN   16/05/95  Fixed bug in configuring threshold values
# M.COMIN   18/10/95  Add event mechanism
#
# mcomin    27/02/96  Porting to TK4.0
#


#----------------------------------------------------------------------------
# PROCEDURE : uifOutputStringPanel - Creates config. panel for UifOutputString
#----------------------------------------------------------------------------

proc uifOutputStringPanel { idx top type } {
   configAnchor     $idx 
   configListValues $idx  $type
}

#----------------------------------------------------------------------------
# PROCEDURE : configUifOutputStr - Updates the data structures describing the
#                                  configuration of the UifOutputString Class
#----------------------------------------------------------------------------

proc configUifOutputStr { idx cv top name } {
   global wdgConfig panOutputAnchor

   set myValues  {} ; set myColors  {} ; set myStrings {}

   set configList [getWdgConfig $idx configList]
   set max [$configList getSize]

   for { set i 0 } { $i < $max } { incr i } {
      set item          [$configList getItem $i]
      lappend myValues  [lindex $item 0]
      lappend myColors  [lindex $item 2]
      lappend myStrings [string trim [lindex $item 1] "\""]
   }

#   puts "myValues = $myValues"
#   puts "myColors = $myColors"
#   puts "myString = $myStrings"

   $cv.$name configure -listColors  $myColors  -listValues $myValues \
                       -listStrings $myStrings -anchor $panOutputAnchor($idx)
}

#----------------------------------------------------------------------------
# PROCEDURE : displayUifOutputStr - Updates the configuration panel according
#                                to the current UifOutputString configuration
#----------------------------------------------------------------------------

proc displayUifOutputStr { idx cv top name } {
   global wdgConfig panStrList panSelectedColor

   set panSelectedColor    [$cv.$name cget -color]
   setWdgConfig $idx color [$cv.$name cget -color]

   set panStrList($idx) [$cv.$name cget -listValues]
   set myColors         [$cv.$name cget -listColors] 
   set myStrings        [$cv.$name cget -listStrings] 

#   puts "-- myValues = $panStrList"
#   puts "-- myColors = $myColors"
#   puts "-- myString = $myStrings"

   set max [llength $panStrList($idx)]

   for { set i 0 } { $i < $max } { incr i } {

      set val [lindex $panStrList($idx) $i]
      set col [lindex $myColors   $i]
      set str [lindex $myStrings  $i]
      set tmp [format $wdgConfig(listFormat) $val \"$str\" $col]

      [getWdgConfig $idx configList] addItem end $tmp
   }
}

