#
# E.S.O. - VLT project
#
# "@(#) $Id: configScale.tcl,v 5.34 2005/09/26 12:44:18 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ----------------------------------------------
# M.COMIN   ??/??/??  created
#
#

#-----------------------------------------------------------------------------
# PROCEDURE : uifScalePanel -  Creates config. panel for UifScale
#-----------------------------------------------------------------------------

proc uifScalePanel { idx top name } {
   global wdgConfig configHelp

   set w1          [getWdgConfig $idx wdgDigits]
   set w2          [getWdgConfig $idx wdgResolution]

   set configHelp  [getWdgConfig $idx configHelp]


   UifEntry $w1 -label " Digits"     -width 3 -labelFont $wdgConfig(lblFont)
   UifEntry $w2 -label "             Resolution" -width 5 -labelFont $wdgConfig(lblFont)


   UifShortHelp::add $configHelp $w1\
      {If digits = 0, scale deliver an integer otherwise a real}

   UifShortHelp::add $configHelp $w2\
       {A real value specifying the resolution for the scale}

   pack $w2 -side left -padx 20

   pack $w1 -side left -padx 5


}


#-----------------------------------------------------------------------------
# PROCEDURE : configUifScale - Updates the data structures describing the
#                              configuration of the UifScale Class
#-----------------------------------------------------------------------------

proc configUifScale { idx cv w name } {
   global wdgConfig ckDbMin ckDbMax  ckOrientation i_min i_max

   set min    [getValue $idx $name [getWdgConfig $idx wdgMin]    ckDbMin]
   set max    [getValue $idx $name [getWdgConfig $idx wdgMax]    ckDbMax]

   set digits     [getInput [getWdgConfig $idx wdgDigits]]
   set resolution [getInput [getWdgConfig $idx wdgResolution]]

   $cv.$name configure  -label  [getConfigInput $idx wdgLabel] \
                        -minVal $min -maxVal $max -orient $ckOrientation($idx)

   $cv.$name configure -digits $digits -resolution $resolution

   if { $ckDbMin($idx) == 0 } { 
      saveWidget $name $i_min  $min 
   } else {
      saveWidget $name $i_min  0
   }   
   
   if { $ckDbMax($idx) == 0 } { 
      saveWidget $name $i_max  $max 
   } else {
      saveWidget $name $i_max  0
   }
}



#-----------------------------------------------------------------------------
# PROCEDURE : displayUifScale - Updates the configuration panel according
#                               to the current UifScale Class configuration
#-----------------------------------------------------------------------------

proc displayUifScale { idx cv w name } {
   global wdgConfig ckOrientation 

   setConfigEntry $idx wdgLabel       [string trimright [$cv.$name cget -label]]
   setConfigEntry $idx wdgDigits      [string trimright [$cv.$name cget -digits]]
   setConfigEntry $idx wdgResolution  [string trimright [$cv.$name cget -resolution]]

   displayMin $idx $name
   displayMax $idx $name 

   set ckOrientation($idx) [$cv.$name cget -orient] 
}
