#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: panEditMisc.tcl,v 5.34 2005/09/26 12:44:29 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    26/05/97  created
#           23/12/97  Insertion cursor does not move any longet with the
#                     widget's movement.
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

#----------------------------------------------------------------------------
# PROCEDURE : panSetCursorCoord - Sets the current cursor position
#----------------------------------------------------------------------------

proc panSetCursorCoord { xscreen yscreen xcv ycv } {
   global par panBox

   set cv [winfo containing $xscreen $yscreen] ;# Get the name of the canvas
   set par(lastX) $par(X)
   set par(lastY) $par(Y)
 
   # Set new coordinates according to the grid

    set par(X) [expr {int([$cv canvasx $xcv $par(GRID)])}]
    set par(Y) [expr {int([$cv canvasy $ycv $par(GRID)])}]

    if {![info exists panBox(cursorBitmap)]} { 
	set panBox(cursorBitmap) [findVLTFile bitmaps/insertCursor.xbm] 
    }
    
    if {[set idx [$cv find withtag insertCursor]] != ""} {
	$cv delete $idx
    }
    
    $cv create bitmap [expr {$par(X) - 15}] $par(Y) -anchor w \
                       -bitmap @$panBox(cursorBitmap) -tag insertCursor

   set panBox(anchor) [list $xcv $ycv]
   catch { unset panBox(last) }
}

proc panBoxInitDrag { x y } {
   global par
#   puts "panBoxInitDrag  $x $y"
   set par(lastX) $x
   set par(lastY) $y
}



proc panBoxDrag { w x y } {
   global panBox
   catch {$w delete $panBox(last)}
   set panBox(last) [eval {$w create rect} $panBox(anchor) \
	            {$x $y -tag panDeleteBox }]
}

proc panSelectMove {w x y } {
   global panBox

   set panBox(itemList) ""

   foreach item [eval $w find enclosed $panBox(anchor) $x $y] {
       if {[$w type $item] == "window"} {
          set tmp [$w itemcget $item -tags]
          lappend panBox(itemList) [lindex $tmp 1]
       } else {
          lappend panBox(itemList) $item
       } 
   }
}

proc panMoveDrag {x y cv} {
   global panBox
   panDragWidget $x $y $panBox(itemList) $cv
   $cv delete panDeleteBox
}

proc panMoveEnd {w x y cv} {
   global panBox
   set panBox(itemList) ""
   panSetEditMode create
}

proc panDeleteObject { w x y cv} {
   global panBox

#   puts "DBG> panDeleteObject $panBox(anchor) $w  $x $y"

   # Get list of objects enclosed in the 'deleteBox'

   set itemList  [eval $w find enclosed $panBox(anchor) $x $y]

   if {! [lempty $itemList]} {
      set msg "Press 'Continue' to delete the widgets"
      append msg "\nThis operation CANNOT BE RECOVERED"

      if {[tk_dialog .dialog "" $msg question 1 Continue Cancel]} {
         $w delete panDeleteBox
         panSetEditMode create
         return
      }
   }

   foreach item [eval $w find enclosed $panBox(anchor) $x $y] {

      if {[$w type $item] == "window"} {
         set tags [$w itemcget $item -tag]
         panDeleteWidget $w [lindex $tags 1]
      } else {
         $w delete $item  ;# Delete a simple canvas item
      }
   }

   $w delete panDeleteBox
   panSetEditMode create
}

#
# ___oOo___
