#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: panTerm.tcl,v 5.34 2005/09/26 12:44:23 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin  15/05/96  created
#

#************************************************************************
#   NAME
#
#   SYNOPSIS
#
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc panTerm { title buffer} {

   global panTermReturn

   set top    .panTerm;  # Define the outer most part of the panel
   set myText  $top.txt; 

   # If the window already exist , just update the contents

   if {[winfo exists $top]} {   
       $myText deleteText 0.0 end
       $myText insertText 0.0 $buffer
       wm title $top $title
       return
   }

   toplevel $top
   set mframe [frame $top.menuFrame]
   pack  $mframe 

   #################################      
   #     Creation of Menu Bar   
   #################################
   
   set menuBar  [ makeMenuFrame $mframe]

   #  File Menu

   set mbFile [addMenu $menuBar  File  1]; 
   addMenuCmd $mbFile "Print On Screen"  0  "panTermPrint $myText"
   addMenuCmd $mbFile "Quit"             0  "panTermQuit $top"

   #  "Help" Menu
    
   set mbHelp [addMenu $menuBar  Help  1 right];      # Help Menu
   addMenuCmd $mbHelp "Extended Help"  0  {puts "Not Implemented"}  

   #################################      
   #     Creation of panel
   #################################

   UifText $myText -width 80 -height 24 \
           -font -Adobe-courier-medium-r-normal--12*-iso8859-1
   
   pack $myText -padx 5 -pady 5 -expand 1 -fill both
   
   $myText insertText 0.0 $buffer 
   
   wm title $top $title
   set tmp [wm protocol $top WM_DELETE_WINDOW]
   wm protocol $top WM_DELETE_WINDOW "$tmp ; panTermQuit $top"
}

proc panTermPrint { w } {
   puts "[$w getText 0.0 end]"
   flush stdout
}

proc panTermQuit { w } {
   global panTermReturn
   set panTermReturn ""
   destroy $w
}





#
# ___oOo___
