#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ptlibCheckDbValue.tcl,v 1.21 2003/11/18 12:40:57 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    06/08/96  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
#      
#      ptlibCheckDbValue <appl> <var> <min> <max>
#
#   DESCRIPTION
#      
#      Get the value of a global variable from the specified application.
#
#      appl     <IN>  Name of the Tcl/Tk application
#      var      <IN>  Name of the DB variable
#      min      <IN>  Minimum Value
#      max      <IN>  Maximum Value
#
#      The procedure generates a log on the standard output of the user action.
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#      SUCCESS   Current value of the variable
#      FAILURE   Returns 0
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ptlibCheckDbValue  { attr args } {

   set min [lindex $args 0]
   set max [lindex $args 1]

   set val [ptlibDbRead $attr NO_DUMP]

   puts "CHECK DB ELEMENT > $attr"


   if {$val < $min || $val > $max} {
     puts "DB ELEMENT $attr VALUE ($val) OUT OF RANGE ($min,$max)"
     return 1
   } else {
     puts "DB ELEMENT CORRECT"
     return 0
   }
}


#
# ___oOo___
