#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ptlibClickButton.tcl,v 1.21 2003/11/18 12:40:55 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    21/09/95  created
#
# mcomin    09/03/96  Porting to Tk4.0 and itcl2.0
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
#      
#      ptlibClickButton <appl> <widget name> ?flag?
#
#   DESCRIPTION
#      
#      Simulate the clicking of a button by a user.
#
#      appl     <IN>  Name of the Tcl/Tk application
#      wdgName  <IN>  Full widget name
#      flag     <IN>  Valid value "-async" :  asynchronous call.
#                     The procedures returns immediately
#                     Default value sets the operation as 'synchrounous'
#
#      The procedure generates a log on the standard output of the user action.
#      
#      If the widget does not exists it generates a proper log and returns
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ptlibClickButton  { appl wdg args } {

   if {[send $appl info proc simulClickButton ] == "" } {
      ptlibInit $appl
   }

   if { [ptlibLogAction $appl $wdg]} { return }

   if {[lsearch $args "-async"] == -1 } {
      set ret [eval send $appl simulClickButton $wdg]  
   } else {
      set ret [eval send -async $appl simulClickButton $wdg]     
   }

   if {$ret != ""} { puts $ret }
   flush stdout
}


proc ptlibClickAckButton  { appl wdg args } {
   set defDelay 1

   if {[lsearch $args "-async"] != -1 } { set defDelay 30 }

   ptlibClickButton $appl $wdg $args

   if {[set idx [lsearch $args "-ackDelay"]] == -1} {
       ptlibAckDialog $appl ".dialog .seqErrDisplay" 0 $defDelay
   } else {
      incr idx
      ptlibAckDialog  $appl ".dialog .seqErrDisplay" 0 [lindex $args $idx]
   }
   
   flush stdout
}


# ___oOo___
