#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ptlibClickListBox.tcl,v 1.21 2003/11/18 12:40:55 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    21/09/95  created
#
# mcomin    09/03/96  Porting to TK4.0 and itcl2.0
#
#************************************************************************
#   NAME
# 
#   SYNOPSIS
#      
#      ptlibClickListBox  <appl> <widget name> <index>
#
#   DESCRIPTION
#
#      The procedures generates a log on the standard output of the user 
#      action.
#      
#      If the widget does not exists it generates a proper log and returns
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

namespace inscope :: {
    if {$tcl_version >= 8.4} {
        ::tk::unsupported::ExposePrivateCommand tkButton*
        ::tk::unsupported::ExposePrivateCommand tkMb*
        ::tk::unsupported::ExposePrivateCommand tkList*
    }
}

proc ptlibClickListBox { appl wdg index } {
  
   set title [ptlibGetTitle $appl $wdg]

   if {[send $appl winfo exists $wdg ] == 0} {
      puts "WINDOW \"$title\" WIDGET $wdg DOES NOT EXIST"
      return
   }

   set myList [send $appl $wdg getComponentPath uifListBox]
   set tmp    [send $appl tkListboxBeginSelect $myList $index]
   
   if { [catch { set what [send $appl $myList get $index] } ]} {
      puts "CANNOT SELECT INDEX $index IN LIST BOX $wdg" 
      return   
   }   

   ptlibLogAction $appl $wdg "SELECT LIST ITEM" "(index = $index) $what"

   send $appl $myList selection set $index 
 
   if {[set var [send $appl ${wdg} cget -variable]] == "" } {
      puts "LIST BOX $wdg HAS NO VARIABLE" 
      return  
   }
 
   send $appl $wdg setVariable $var 
   send $appl $myList selection clear $index
    
   return
}


#
# ___oOo___
