#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: ptlibGetValue.tcl,v 1.21 2003/11/18 12:40:56 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin  21/09/95  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
#      
#      ptlibGetValue <appl> <var> <flag>
#
#   DESCRIPTION
#      
#      Get the value of a global variable from the specified application.
#
#      appl     <IN>  Name of the Tcl/Tk application
#      var      <IN>  Name of the global variable
#      flag     <IN>  "dump" : specifies to dump the current value on screen
#
#      The procedure generates a log on the standard output of the user action.
#      
#      If <var> does not exists it generates a proper log.
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#      SUCCESS   Current value of the variable
#      FAILURE   Returns 0
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc ptlibGetValue  { appl var {flag {0}} } {

  set title [ptlibGetTitle $appl "."]

  if {[send $appl info exists $var ] == 0} {
      puts "WINDOW \"$title\" VARIABLE $var DOES NOT EXIST"
      return 0
  }

  set val [send $appl set $var]
   
  if {$flag == "dump" } { puts "WINDOW \"$title\" VARIABLE $var = \"$val\"" }
  
  return $val
}


#
# ___oOo___
