#***********************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: wpTotal.tcl,v 1.23 1998/03/09 08:55:29 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    12/04/95  created
# gfilippi  31/05/95  set as a separate file from wpAccountLib.tcl
#
#************************************************************************
#   NAME
#
#     wpTotal - compute totals
#
#   DESCRIPTION
#
#     Internal procedure for 'Activity Account' panel (wpActivity.pan)
#
#------------------------------------------------------------------------
#

#------------------------------------------------------------------------
# PROCEDURE : wpTotal  - Compute totals : each entry stores the data into
#                        the variable gvar(cell_col_row)
#                        - col , indicates the column index (1 < col < 9)
#                        - row , indicates the row    index (1 < row < 20)
#------------------------------------------------------------------------

proc wpTotal { } {

   global cv gvar wpActRecord wpListWidget

   set max [$wpListWidget getSize] ; incr max

   #-------------------------------------------------
   # Update total account for each activity (rows)
   #-------------------------------------------------

   for { set row 1 } {$row < $max } {incr row} {

       set total 0
       set idx   [expr $row - 1]

       for { set i 1 } {$i < 8} {incr i} {

           if {[set myVal $gvar(cell_${i}_${row})] == "" } {
              saveRecField $idx $i 0 ; # Update Data Structure             
           } else {

              incr total $myVal ;          # Calculate total
              saveRecField $idx $i $myVal; # Update Data Structure

             if { $myVal == "0" } {  set gvar(cell_${i}_${row}) "" }
	   }
       }

       set gvar(cell_8_${row}) $total; # Update total
       saveRecField $idx 8 $total ;    # Update Data Structure
   }


   #-------------------------------------------------
   # Update total account for each day (columns)
   #-------------------------------------------------
   
   set gvar(totWeek) 0 ; # Total hours in the week

   for { set i 1 } {$i < 8 } {incr i} {

       set total 0

       for { set row 1 } {$row < $max} {incr row} {

           if {$gvar(cell_${i}_${row}) == "" } { continue }

           incr total $gvar(cell_${i}_${row});  # Calculate total
       }

       set gvar(col_${i}) $total ; # Update total for single day
       incr gvar(totWeek) $total ; # Update total for the whole week
   }
}


#
# ___oOo___
