# E.S.O. - VLT project 
# $Id: tclutilConfig.sh.in,v 1.26 2005/02/06 19:24:21 vltsccm Exp $
#
# tclutilConfig.sh --
#
# This shell script (for sh) is generated automatically by the
# configure script.  It will create shell variables for most of
# the configuration options discovered by the configure script.
# This script is intended to be included by other configure scripts
# so that they don't have to figure this all out for themselves.
#
# The information in this file is specific to a single platform.
#
# who             when       what
# --------------  --------   ---------------------------------------------
# Allan Brighton  21 Nov 97  Created
#

# version of the Tclutil library
TCLUTIL_VERSION='1.2.8'

# C Compiler used for TCLUTIL
TCLUTIL_CC='gcc -fwritable-strings'

# C++ Compiler used for TCLUTIL
TCLUTIL_CXX='gcc'

# -I option for make depend with C++ sources
TCLUTIL_CXX_INCLUDE='-I'

# OS version
TCLUTIL_OSVERSION='Linux-2.6.11.6'

# target to use for make depend
TCLUTIL_DEPEND_TARGET='dep'

# This expands to an environment variable name LD_LIBRARY_PATH or SHLIB_PATH
TCLUTIL_LD_VARNAME='LD_LIBRARY_PATH'

# Flags to pass to cc when compiling the components of a shared library:
TCLUTIL_SHLIB_CFLAGS='-fPIC'

# Base command to use for combining object files into a shared library:
TCLUTIL_SHLIB_LD='gcc -ansi -shared -fPIC'

# Suffix to use for the name of a shared library.
TCLUTIL_SHLIB_SUFFIX='.so'

# Either '$LIBS' (if dependent libraries should be included when linking
# shared libraries) or an empty string.  See Tcl's configure.in for more
# explanation.
TCLUTIL_SHLIB_LD_LIBS='${LIBS}'

# Library file(s) to include in tclsh and other base applications
# in order to provide facilities needed by DLOBJ above.
TCLUTIL_DL_LIBS='-ldl'

# Flags to pass to the compiler when linking object files into
# an executable tclsh or tcltest binary.
TCLUTIL_LD_FLAGS=' -Wl,--export-dynamic'

# Flags to pass to cc, such as "-Wl,-R,/usr/local/tcl/lib", that tell the
# run-time dynamic linker where to look for shared libraries such as
# libtcl.so.  Used when linking applications.  Only works if there
# is a variable "LIB_RUNTIME_DIR" defined in the Makefile.
TCLUTIL_LD_SEARCH_FLAGS='-Wl,-rpath,${LIB_RUNTIME_DIR}'

# root of tclutil source tree
TCLUTIL_SRC_ROOT='/home/vltnoccs/VLTSW/DMD/cat/tclutil'

# list of tclutil subdirectory pathnames (depends on --with-notcl flag)
TCLUTIL_SUBDIRS='/home/vltnoccs/VLTSW/DMD/cat/tclutil/util                      /home/vltnoccs/VLTSW/DMD/cat/tclutil/tclutil 		     /home/vltnoccs/VLTSW/DMD/cat/tclutil/tix'

# same as above, but without the Tix subdir
TCLUTIL_SUBDIRS_NOTIX='/home/vltnoccs/VLTSW/DMD/cat/tclutil/util                           /home/vltnoccs/VLTSW/DMD/cat/tclutil/tclutil'

# If this is true, build library with no Tcl access
TCLUTIL_NO_TCL='0'

# -I flag for X include files
TCLUTIL_XINCSW='-I/usr/X11R6/include'

# -L and -l flags for X libs
TCLUTIL_XLIBSW='-L/usr/X11R6/lib -lX11 -lXext'

# directory containing X libs
TCLUTIL_XLIBDIR='/usr/X11R6/lib'

# flags for linking tcl and ext libs
TCLUTIL_TCL_LIB_SPEC='-L/vlt/JAN2006/tcltk/lib -ltcl8.4${TCL_DBGX}'
TCLUTIL_TK_LIB_SPEC='-L/vlt/JAN2006/tcltk/lib -ltk8.4'
TCLUTIL_TCLX_LIB_SPEC='-L/vlt/JAN2006/tcltk/lib/tclx8.4 -ltclx8.4'
TCLUTIL_ITCL_LIB_SPEC='-L/vlt/JAN2006/tcltk/lib/itcl3.3 -litcl3.3'
TCLUTIL_ITK_LIB_SPEC='-L/vlt/JAN2006/tcltk/lib/itk3.3 -litk3.3'
TCLUTIL_BLT_LIB_SPEC='-lBLT'

# include flags
TCLUTIL_TCLINCSW='-I/vlt/JAN2006/tcltk/include -I/vlt/JAN2006/tcltk/include/itcl'
TCLUTIL_TKINCSW='-I/vlt/JAN2006/tcltk/include -I/vlt/JAN2006/tcltk/include/itcl'

# tcl library files
TCLUTIL_TCL_LIBRARY='/vlt/JAN2006/tcltk/lib/tcl8.4'
TCLUTIL_TK_LIBRARY='/vlt/JAN2006/tcltk/lib/tk8.4'
TCLUTIL_BLT_LIBRARY='/vlt/JAN2006/tcltk/lib/blt2.4'

# other package versions used by TCLUTIL
TCLUTIL_TCL_VERSION='8.4'
TCLUTIL_TK_VERSION='8.4'
TCLUTIL_ITCL_VERSION='3.3'
TCLUTIL_ITK_VERSION='3.3'
TCLUTIL_TCLX_VERSION='8.4'
TCLUTIL_BLT_VERSION='2.4'

# major versions
TCLUTIL_TCL_MAJOR_VERSION='8'
TCLUTIL_TK_MAJOR_VERSION='8'
TCLUTIL_ITCL_MAJOR_VERSION=''

# system libs to link
TCLUTIL_LIBS=' -lnsl -lresolv -ldl'

# TCLUTIL install dirs
TCLUTIL_DESTDIR='${INSTALL_TARGET}'
TCLUTIL_BINDIR='${INSTALL_TARGET}/bin'
TCLUTIL_LIBDIR='${INSTALL_TARGET}/lib'
TCLUTIL_INCDIR='${INSTALL_TARGET}/include/tclutil'
TCLUTIL_MANDIR='${INSTALL_TARGET}/man'
TCLUTIL_DIR='${INSTALL_TARGET}/lib/tclutil'

# Tcl/Tk defines
TCLUTIL_DEFS='-DHAVE_CONFIG_H'


# default location of Tclutil library files
TCLUTIL_LIBRARY='${INSTALL_TARGET}/lib/tclutil'

# location of Tclutil library files in source tree
TCLUTIL_BUILD_LIBRARY='/home/vltnoccs/VLTSW/DMD/cat/tclutil/tclutil/library'

# -I flags to pick up the tclutil include files from the build dirs
TCLUTIL_BUILD_INCLUDES='-I/home/vltnoccs/VLTSW/DMD/cat/tclutil/util/include -I/home/vltnoccs/VLTSW/DMD/cat/tclutil/tclutil/include -I/home/vltnoccs/VLTSW/DMD/cat/tclutil/tix/unix'

# String to pass to linker to pick up the Tclutil library from its
# build directory.
TCLUTIL_BUILD_LIB_SPEC='-L/home/vltnoccs/VLTSW/DMD/cat/tclutil -ltclutil'

# static version of above
TCLUTIL_BUILD_LIB_SPEC_STATIC='/home/vltnoccs/VLTSW/DMD/cat/tclutil/libtclutil.a'

# String to pass to linker to pick up the Tclutil library from its
# installed directory.
TCLUTIL_LIB_SPEC='-L${INSTALL_TARGET}/lib -ltclutil'

# static version of above
TCLUTIL_LIB_SPEC_STATIC='${INSTALL_TARGET}/lib/libtclutil.a'


# Flags to pass to cc, such as "-Wl,-R,/usr/local/tcl/lib", that tell the
# run-time dynamic linker where to look for shared libraries such as
# libtcl.so.  Used when linking applications.  Only works if there
# is a variable "LIB_RUNTIME_DIR" defined in the Makefile.
TCLUTIL_LIB_RUNTIME_DIR='/vlt/JAN2006/NOCCS/lib:/vlt/JAN2006/NOCCS/lib/itcl:/vlt/JAN2006/tcltk/lib:/vlt/JAN2006/tcltk/lib/itcl:/vlt/JAN2006/tcltk/lib/itcl3.3:/vlt/JAN2006/tcltk/lib/itk3.3'

# The environment variable TCLTK_ROOT may be set before running configure
# to help locate the correct Tcl/Tk installation
TCLUTIL_TCLTK_ROOT='/vlt/JAN2006/tcltk'
