.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  bobBaseObject.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH BobBaseObject n "VLTSW-JAN2006 27/10/05-16:47"
.SH NAME 
BobBaseObject - base class for Template and Observation Blocks object

.SH SYNOPSIS 
.nf 
.LP 
BobBaseObject <obj_name>|#auto <type> <rawData> <canvas>\\
                     ?-<publicVar> <value>?

.SH DESCRIPTION 
.nf 
.LP 
This class inherits from BobVisualPCTree and defines a common base for TPL
and OB objects. This includes login window functionality, the stepping
mode (NORMAL / BREAK / SKIP), handles selection and the initialisation
of data array.

.SH METHODS 
.nf 
.LP 
constructor: see [incr Tcl]
destructor: destroy the object and unmark if required; see [incr Tcl]
configure: see [incr Tcl]

disableFlowCtrlChange: effectively disable the use of the "flowCtrlChange"
    method
enableFlowCtrlChange: effectively enable the use of the "flowCtrlChange"
    method
draw <ulx> <uly>: draw the object, add the step mode icon, add the
    bindings to 'flowCtrlChange' and the mark which will highlight the
    object and display its log; return the proper <uly> for a next similar
    object.
getObdSource: return obd source (one of OH file or TemplateClient)
getRawData: returns the rawData used for creation
paste: first check for type mismatch etc... extende by subclass
populate: creates the sub-tree objects after the data array has been
    created - virtual here
mark: select this object
setRawData <rd>: fills the raw data bit
toggle_mark: toggle marked object
flowCtrlChange: allows to set the current flowCtrl value (NORMAL / BREAK /
     SKIP); update the canvas at the same time
unmark: unmark this object

.SH CLASS PROCEDURES 
.nf 
.LP 
marked: returns currently marked object
markedIsOB: returns 1 if currently marked object is an OB
resetStatus: reset the basic configuration for all objects on the canvas:
    status = idle
    PC = -1
    clear templates logs
sendStatus <cmd> <obds> <str> ?<force>? : send the SCRIPT command to the
    schedule process (OH) with <cmd> and <str> as arguments, provides the
    source of the OBD is OH (i.e. <obds> is set to "OH"). The <force> flag
    is for use in combination with ::bob::internal::config(tplEvents): if
    the latter is false, there are no "events" sent to OH, unless the
    <force> flag is set; by default <force> is false.

.SH VARIABLES 
.nf 
.LP 
names: defines array of key for data storage
status: define the cstatus of the object (idle / running / paused /
      aborted / fault)
flowCtrl: define the stepping through mode (NORMAL / BREAK /SKIP)
type: defines type of the object for data storage

rawData (protected)

