.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  bobMobsBase.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH BobMobsBase n "VLTSW-JAN2006 27/10/05-16:47"
.SH NAME 
BobMobsBase - Multiple Observation Software base class


.SH SYNOPSIS 
.nf 
.LP 
BobMobsBase - widget to create/edit mobs files.

.SH DESCRIPTION 
.nf 
.LP 
BobMobsBase provides a table based widget with two scrollbars to
edit/create mobs files.

mobs files edit/display SETUP keywords from .DET, .INS and
 .TEL files. Therefore the first 3 columns of the widget are reserved
to type file names of the type mentioned above.

Keywords defined in the loaded setup files can be selectively
displayed into table's columns, using the method configColumns. It
presents a listbox where multiple selection is allowed. Table columns
are added removed as needed, table geometry is kept constant.

Finally it provides methods for loading and writing mobs files
out of the contents of the widget, the generated file is in
PAF format.

The handling of SETUP keywords and files is done through seq_oslx.

.SH PUBLIC VARIABLES 
.nf 
.LP 
None.

.SH PUBLIC METHODS 
.nf 
.LP 
addRow : add a line to the bottom of the table
configColumns: create a toplevel listbox to select attributes to display
      in the table widget.

getTableData: generates and OBD string in PAF format.

load <obd>: load a table from and OBD string <obd>. It is assumed that <obd>
      is indeed MOBS-compliant, i.e. that the 2nd till last template are
      generic ones.
tableBrowse <row col> : validate value of cell <row col>

.SH PUBLIC OPTIONS 
.nf 
.LP 
-cols      number of columns
-rows      number of rows
-arrayvar  name of global array variable where values are stored by this
           widget (i.e. the value of each cell is an element in the array)
-helpvariable (name: helpVariable, class: HelpVariable)
    The name of the global Tcl-variable which is used to display help text
    when the cursor is over the table.
-helptext (name: helpText, class: Help)
    The short help text for the scrolled listbox

.SH FILES 
.nf 
.LP 
A test INS_ROOT is provides under test directory

.SH ENVIRONMENT 
.nf 
.LP 
INS_ROOT file structure is required.

.SH CAUTIONS 
.nf 
.LP 
A working INS_ROOT is needed, INS_USER must be defined.

.SH EXAMPLES 
.nf 
.LP 
Creates a BobMobsBase object, updates array gvar.

% BobMobsBase .m -arrayvar gvar

Load file eg.mobs inside the widget, arrayVar uodated
accordingly.

% .m load eg.mobs

Show all keywords readed and allow te user to select
the ones to be displayed/edited.

%.m configColumns

