.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  bobTPL.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH BobTPL n "VLTSW-JAN2006 27/10/05-16:47"
.SH NAME 
BobTPL - base class for template objects

.SH SYNOPSIS 
.nf 
.LP 
BobTPL <obj_name>|#auto \\
       <rawData> <obdSource> <canvas> <scrolledText> \\
       <initialObsInfo> <tplNr> <args>

.SH DESCRIPTION 
.nf 
.LP 
defines template objects - inherits BobBaseObject

.SH METHODS 
.nf 
.LP 
constructor: contruct the BobBaseObject, and do the store in array (always
    done at creation time for templates). Do also a first check on
    the parameters value;see [incr Tcl]
destructor: delete any saved paramfiles and proceed with base object
    destruction;
configure: see [incr Tcl]

abort: request an abort of the template's execution. This will set a
    variable called "abort", which can be upvar-ed by the template.
ackabort: acknowledge the abort (sendStatus)
unmark: extend 'unmark' to also clear the log of this template
editRawData ?<cats>? ?<pars>?: pops up the TPL editor. The set of parameters
    to be edited depends on the 2 arguments:
    <cats> : name of a single keyword-category to be edited, or the word
             "all" to include all categories. Default: all
    <pars> : name of specific keywords to edit (assuming <cats> is not set
             to a "all"). Default: all
execute <OBSinfo> <seqNr> <statVarName>: execute the template, whereby
    its sequential number in its parent OB is <seqNr>;
    <OBSinfo> contains relevant info passed to the template for execution.
    This method returns potentially messages and the exec-status in a
    variable whose name is given in <statVarName>. Possible values for
    exec-status:
    -3 : MustRepeat
    -2 : Paused
    -1 : Aborted; returns also the string "ACK ABORT".
     0 : OK - normal completion; return value will be empty
    >0 : error - the return value of the method itself will contain an
         error message
          1: Could not find the template signature file
          2: Could not find the sequencer script
          3: TPL ID has illegal format
         10: Error returned by the template
         11: Template was aborted at OS-level
    Template scripts should return the following way, with proper values:
       return "<RA> <Dec>" : for successfully terminated acquisition
            templates, with <RA> and <Dec> the coordinates of the acquired
            object (both in degrees, as a float number, identical to how
            the primary FITS keywords RA and DEC are written)
       return {} or return without value: if all went OK, for all but
            acquisition templates
       error "message" : if there is some error within the template, or an
            error  returned from the OS-level (e.g. ABORT).  The setting
            of the ABORT-flag within BOB causes the template to skip
            SETUP and START commands.  When the template sees the abort-
            flag (see above), it should return an "ACK ABORT".
getEditedData: returns the edited data in the form of "raw" template data
getExpNr: returns a list with the current exposure number and the number of
          exposures (TPL(EXPNO) resp. TPL(NEXP)).
getTplId: returns TPL(ID); used to make nice tabs label wile editing an OB
getTplType: returns TPL(TYPE)
init_editRawData <pathName> ?<cats>? ?<pars>?: initializes the TPL-editor
    widget <pathName> with the data as indicated by the two optional args:
    <cats> : name of a single keyword-category to be edited, or the word
             "all" to include all categories. Default: all
    <pars> : name of specific keywords to edit (assuming <cats> is not set
             to a "all"). Default: all
mark: 'select' this Tpl and display its log in the corresponding text
    widget.
mustRepeat: request a MUSTREPEAT of the template's execution; this implies
    an abort (see above).
paste <object> <where> : paste <object> <where> relative to this
pause: pause the template
populate: create all BobVisualTree child associated with this template
printLog: prints the log
showExpNr: shows current exposure number in canvas area display
updateRawData: builds a TPL raw-data string starting from the keyword
    arrays.

.SH CLASS PROCEDURES 
.nf 
.LP 
checkAbortFlag: convenience procedure to check if bob's ABORT button was
    pressed.  It will automatically generate an "ACK ABORT" error message
    if the abort flag was set, otherwise it returns with an empty string

finishOB ?-status <status>?: tell the OB that when this template finishes,
    it should skip the remaining templates and return the termination
    status <status> (default: TERMINATED) to OH.

getResult <name> : retrieve the value for the previously stored <name>
    variable. Remark that all variables are erased when the first TPL of
    an OB starts it execution. In other words, result-passing from one
    template to another is only possible within a single OB.
    Bob itself stores the execution status (0 = OK, 1 = error) of the
    last template in the variable "tplExitStatus". This variable can
    then be used by the call-back script to decide on proper actions.

pafReady <pathName> ?<keep>? : send an event to OH signalling that the
    PAF-file <pathName> is ready for download. This file will be deleted by
    bob after OH fetched it, unless the boolean variable <keep> is set to
    true (or 1). Unlike other events, this one will be sent to OH even if
    the template executing this command is part of an OB which was not
    downloaded from OH.
    If <pathName> is a directory, there will be an event generated to OH
    for every single file on that directory.

seeBobVars ?-localcopy <listOfCats>?: in the absence of the -localcopy
    option, issues the proper set of "upvar" instructions, within the
    context of the calling procedure, to make the various category-arrays
    created/owned by BOB accessible as local arrays with the same name.
    This procedure returns a list with as first element the list of
    category names which are then locally accessible.
    If the "-localcopy" option is specified, <listOfCats> must be a list of
    keyword category-arrays, for which there will be then a *copy* created
    in the context of the calling procedure (i.e. these arrays are *not*
    linked to the ones owned and accessed by BOB). The category OBS can
    be included within <listOfCats>.

sendCmd <timeout> <cmd> ?<param1>? ?<param2>? ...: convenience procedure to
    send commands to OS. This is the one and only way template-scripts are
    allowed to use for communication with OS.
    <timeout>: timeout value (in ms) for reply; 0 means return immediately
               with the commandId - do not wait for replies; this argument
               is not taken into account if the template-simulation mode
               is on.
    <cmd>    : command; this is either a commandname alone (in which case
               pararameters can be given in <paramX>) or it includes some
               parameters (more parameters can be given as <paramX>).
               Typical examples of commandnames are SETUP and START, of
               parameters are "-file <fileName>" and
               "-function <function1> <value1> [<function2> <value2> .....]"
    <paramX> : parameter for <cmd>, if not already included as part of
               <cmd>.
    This procedure returns:
    - reply on command if waiting for last reply (<timeout> # 0).  Remark
      that this reply is the new expoId value when the first SETUP command
      for a new exposure is given (with an expoId-argument equal to 0).
      Only the last reply on the command is returned.
    - cmdId if command was sent OK and <timeout> is set to 0; this can
      then be used by the caller to e.g. attach an event (see seq_evtAttach)
      to incoming replies on this command.
    - error (with message) if any error occurs or if ABORT flag is
      acknowledged
    There are a number of messages logged automatically logged by this
    procedure into BOB's template log window; the commands sent will be
    shown in green if operating in verbose mode (see configuration panel),
    while in this case normal or error replies will be shown in green resp.
    red. If <cmd> is WAIT, there will also be a message logged indicating
    the termination of the exposure, when the final reply comes in.
    Remark that sendCmd will not send any of a list of commands once the
    abort flag has been set. This list can be defined/edited via the
    configuration panel. The skipping of such commands is indicated in BOB's
    template log window.

sendObsKeys ?<timeout>? ?-array <listOfCats>?: convenience procedure to send
    the OBS and DPR keywords, plus some TPL keywords, to OS. This is
    normally done automatically by bob when a "START" command is
    given within the template; however, there are cases where data
    can be produced without starting an exposure, i.e. without a START
    command. The "sendObsKeys" procedure provides for these cases a
    means to still have the proper OBS-, DPR- and TPL-keywords recorded
    into the FITS header. The default timeout for OS to reply is 2000 ms.
    Remark that a call to sendObsKeys will automatically increase the
    exposure number (TPL EXPNO), so this proc should only be called once
    per data file, and only if there is no START command involved.
    The "-array <listOfCats>" optional pair is only legal in case OS is
    not defined (i.e. BOB is used for particular engineering purposes).
    <listOfCats> is now limited to OBS only. By using this optional
    argument, the array OBS will become available at the level that this
    procedure is called. Remark that during normal operation (with OS)
    there is no need to access the OBS keywords passed in the OB.
    (This "-array <listOfCats>" option is actually deprecated: please use
    "seeBobVars -localcopy <listOfCats>" instead).

setCallBack <script>: set the script to be evaluated upon termination of
    this template to <script>, thereby overriding - for this template
    only - the setting in the configuration panel of the default template
    call-back script.
    <script> will be invoked whether or not the template returned an error.
    It can find out the termination status of the template script via a
    "getResult tplExitStatus" command (0 = OK, 1 = error). It
    is up to the call-back to decide if and to what extent it should
    continue if the template script returned with an error.
    If the call-back script needs to get access to values the template
    script has set, the "setResult" and "getResult" mechanism can be used.
    Remark that these call-backs should not be seen as an extension of the
    template's functionality (e.g. to prepare/start exposures). Instead,
    their typical use is to log the template's termination or to put the
    instrument in a safe state. For that reason. this call-back's return-
    status does NOT influence the overall return-status of the template.

setResult <name> <value>: set the <value> for the variable <name>; this
    value can then be retrieved by another template in the same OB -
    see "getResult".

tplLog <text> ?<colour> ?<underline>??
    append <text> to the current log-text, in colour <colour> (default is
    standard default for text), and underlined if the boolean <underline>
    is set. <text> is allowed to contain newline characters.
    Remark that when "verbose communication" is on, the messages sent to
    OS are logged in blue, and OK-replies are logged in SpringGreen4.
    Errors come logged in red. The messages which are always added
    automatically by "sendCmd" (e.g. "starting exposure n of m...") are
    underlined. These colour-schemes of bob should be respected, in order
    to avoid confusion.

.SH SEE ALSO 
.nf 
.LP 
ICD between the VLT Control SW and the Observation Handling Subsystem
(VLT-ICD-ESO-17240-19200)

