.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqProgressBar.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH SeqProgressBar n "VLTSW-JAN2006 27/10/05-16:47"
.SH NAME 
   SeqProgressBar - panel editor class to display a progress bar

.SH SYNOPSIS 
.nf 
.LP 
   SeqProgressBar <windowName> <varName> ?<options>?

.SH DESCRIPTION 
.nf 
.LP 
   SeqProgressBar is a panel editor class that displays a barchart showing
   the progress of some action. A new object will get the name <windowName>
   as a toplevel window. The progress bar is linked with the global
   variable <varName>, and the barchart is updated whenever that global
   variable is touched.

.SH OPTIONS 
.nf 
.LP 
  Options represent public variables of the object and can be set with:

    <windowName> configure -<option1> <value1> ...

   SeqProgressBar accepts following configuration options:
    -font <fontName> : the font for the text to be displayed
    -min  <minVal>   : the minimum value on the barchart; 0 by default
    -max  <maxVal>   : the maximum value on the barchart; 100 by default
    -text <text>     : the text (message) to appear within the object;
                       empty by default
    -title <text>    : title for the toplevel <windowName>
    -variable <var>  : name of the global variable which is linked to the
                       progress (should have a value between <minVal> and
                       <maxVal>)

.SH EXAMPLE 
.nf 
.LP 
 seqWish> set day [clock format [clock seconds] -format %j]
 seqWish> SeqProgressBar .p day -text "Year 2001 Progress"  \\
          -max 365 -title "My 2001 Progress Bar"
 seqWish>

