.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  bobFindLib.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH bobFindObd n "VLTSW-JAN2006 27/10/05-16:47"
.SH NAME 
bobFindObd, bobFindSeq, bobFindSound, bobFindTsf, bobFindVlt
    - BOB Find File Library

.SH SYNOPSIS 
.nf 
.LP 
bobFindObd <obd> ?<insMode>?
bobFindSeq <template> ?<insMode>?
bobFindSound <soundFile>
bobFindTsf <templateSigFile> ?<insMode>?
bobFindVlt <relPathName>

.SH DESCRIPTION 
.nf 
.LP 
The functions contained herein locate a given file according to the
specification of the ICD VCS-OH and related documents.  Parts of this
code have been taken over from or are inspired by vccFindLib.

bobFindIns: locates a file by its relative path.  The file given as a
   relative path is searched in the following directories in the order
   given.
    1. in the $INS_ROOT/$INS_USER area:  "$INS_ROOT/$INS_USER/<relPathName>"
          only if the environment variables INS_ROOT and INS_USER are set
    2. in the $INS_ROOT/SYSTEM area:     "$INS_ROOT/SYSTEM/<relPathName>"
          only if the environment variable $INS_USER is not set to SYSTEM

bobFindVlt: locates a file by its relative path.  The file given as a
   relative path is searched in the same directories as the seq_findFile
   command does, i.e. (in the order as given here):
    1. in the current working directory: "./<relPathName>"
    2. in the current module area:       "../<relPathName>"
    3. in the $MODROOT:                  "$MODROOT/<relPathName>"
    4. in the $INTROOT:                  "$INTROOT/<relPathName>"
    5. in the $VLTROOT:                  "$VLTROOT/<relPathName>"

bobFindSound: locates a sound file, given its filename, without pathname,
   and with or without ".au" extension, under the standard VLT path.

bobFindSeq: locates a sequencer script belonging to a template, given its
   filename, without pathname, and with or without ".seq" extension.  The
   <insMode> argument indicates the instrument mode, so the INS-
   subdirectories that will be searched will include both the <insMode> and
   COMMON branches.  If <insMode> is not specified, only the COMMON branch
   will be searched. Within that scheme, first the TEMPLATES/SEQ
   subdirectory is searched, then (for backward compatibility reasons) the
   SEQUENCES subdirectory.

bobFindTsf: locates a template signature file, given its filename, without
   pathname, and with or without ".tsf" extension.  The <insMode> argument
   indicates the instrument mode, so the INS-subdirectories that will be
   searched will include both the <insMode> and COMMON subdirectory.  If
   <insMode> is not specified, only the COMMON subdirectory will be
   searched. Within that scheme, first the TEMPLATES/TSF subdirectory is
   searched, then (for backward compatibility reasons) the SEQUENCES
   subdirectory.

bobFindObd: locates an observation description file, given its filename,
   without pathname, and with or without ".obd" extension.  The <insMode>
   argument indicates the instrument mode, so the INS-subdirectories that
   will be searched will include both the <insMode> and COMMON subdirectory.
   If <insMode> is not specified, only the COMMON subdirectory will be
   searched. Within that scheme, first the TEMPLATES/OBD subdirectory is
   searched, then (for backward compatibility reasons) the SEQUENCES
   subdirectory.

.SH RETURN VALUES 
.nf 
.LP 
The absolute path of the first found file is returned, or an empty string
if none was found.

The file must be readable for the calling user, otherwise it will be
ignored even if it exists.

.SH FILES 
.nf 
.LP 
The specified files are accessed by the procs in read-only mode. They must
be readable by the calling user.

.SH ENVIRONMENT 
.nf 
.LP 
INS_ROOT - path to INS root
INS_USER - name of user, corresponding to a subdirectory under $INS_ROOT

.SH SEE ALSO 
.nf 
.LP 
vccFindLib(n)

