.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  bobWish.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH bobWish n "VLTSW-JAN2006 27/10/05-16:47"
.SH NAME 
bobWish - shell version of bob

.SH SYNOPSIS 
.nf 
.LP 
bobWish ?-ccsProcName <name>? ?-configFile <file>? ?<scriptFile>?

.SH DESCRIPTION 
.nf 
.LP 
This is a shell implementation of bob. The start-up parameters are similar
as for bob, i.e. you can specify the <name> under which this process will
register itself with the CCS environment, and pick up configuration
parameters from a different <file> than the default ~/.bobrc. If you do
not wish to run bobWish interactively, or need to run some script before
you enter into interactive mode, you can also pass the name of a
<scriptFile>.

BobWish contains dummy objects for all widget related operations. The
actions accessible via buttons or menus in bob are here activated through
the following set of commands :
    bobAbort <reason>
       abort the currently executing OB
    bobContinue ?-foreground?
       continue the currently paused OB
    bobDisplayLog
       display the log of the current OB-object
    bobHelp
       display a help text
    bobInfo
       give info about the loaded OBs and their state
    bobNextObsBlocks ?<nr>|file? ?<filename>?
       load <nr> OBs from the scheduler process, or an OBD from a file.
       In the latter case, if <filename> is not given, a file-selection
       widget will pop-up.
    bobPause
       stop the currently executing OB
    bobPrint
       print the log of the current OB
    bobRepeat <reason>
       tell the scheduler process to repeat this OB at a later stage,
       giving also a textual <reason>. This implies an abort.
    bobReset
       mark all currently loaded OBs as freshly loaded
    bobSaveConfig
       save the configuration parameters in the configuration file.
    bobSaveConfigAs ?<file>?
       save the configuration parameters into <file>, or if <file> is
       not specified, bring up a file selection box first.
    bobSetup
       display a help text, listing all the configuration commands.
    bobSnapshot
       dump bob-related info and logfiles to a timestamped directory.
    bobStart ?-foreground?
       start the OB

If the -foreground (of -fg) flag is given (valid for the bobStart and
bobContinue commands), control will be passed back to the shell *after*
the OB has terminated, instead of running it in the background and
returning control immediately.

.SH CAUTIONS 
.nf 
.LP 
Some dialogs are still kept with tk. This depends partially on the
setting of "bobUserLevel".

