.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  seqDebug.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH dputs n "VLTSW-JAN2006 27/10/05-16:47"
.SH NAME 
dputs, breakpoint, showInfo - A couple of Tcl-debug procedures

.SH SYNOPSIS 
.nf 
.LP 
source seqDebug.tcl

dputs ?<args>?
breakpoint ?<level>?
showInfo ?<level>?

.SH DESCRIPTION 
.nf 
.LP 
dputs: prints out the <args> to stderr, but only if the global Tcl variable
       "Debug" is set to the name of the procedure we want to debug, or to
       "toplevel" if the toplevel is to be debugged. If no arguments are
       passed, a call to this procedure is equivalent to setting a
       breakpoint (provided "Debug" is set to the name of the procedure to
       debug).

breakpoint: set a breakpoint.  Four commands are interpreted directly by
            the breakpoint procedure itself:
               + to move up the call stack
               - to move down the call stack
               ? to print information about the current stack frame
               C return from a breakpoint
            All other commands are evaluated in the current stack frame
            The optional argument <level> indicates how many more levels to
            go up, in case several of these debug-procedures are nested
            (e.g. when dputs calls breakpoint)

showInfo: print useful information about the stack level (stack level,
          procedure name and arguments) to stderr.

Based on: "PracTcl Programming Tips", Linux Journal, October 1995
by Stephen Uhler

.SH RETURN VALUES 
.nf 
.LP 
as any Tcl procedure

.SH CAUTION 
.nf 
.LP 
The breakpoint proc seems to have some problems with namespaces, i.e
when in a child namespace it can complain that perfectly fine procedures
are not procedures. It looks like a bug in the "uplevel" command.
