.\" This Man Page has been automatically produced. DO NOT EDIT THIS FILE!!!!!!
.\" Input file:  rtdbRtd.tcl
.\" Formatter :  @(#) $Id: docDoManPages.c,v 1.37 2005/09/30 13:12:01 vltsccm Exp $
.\" -----------------------------------------------
.TH rtdbRtd.tcl n "VLTSW-OCT99 27/10/05-16:50"
.SH NAME 
rtdbRtd.tcl - Toplevel widget for the base RTD application.

.SH SYNOPSIS 
.nf 
.LP 
rtdbRtd <path> ?options?

.SH DESCRIPTION 
.nf 
.LP 
This class defines the top level window for the base RTD.
It inherits the Rtd toplevel widget, redefines and adds the application
specific methods which are used to
- load the plugins
- add menu items
- configure menu the bar according to user definitions.

.SH PARENT CLASS 
.nf 
.LP 
     ::rtd::Rtd

.SH PUBLIC METHODS 
.nf 
.LP 
     add_transCmd {cmd}
           Add a command which is evaluated whenever the image transformations
           change (rotate, flip)

     add_scaleCmd {cmd}
           Add a command which is evaluated when the image was scaled

     add_rapidPreCmd {cmd}
           Add a command which is evaluated before a rapid frame is displayed

     add_rapidPostCmd {cmd}
           Add a command which is evaluated after a rapid frame was displayed

     add_updateValues {cmd}
           Add a command which is evaluated when cut levels were changed

     add_notify {cmd}
           Add a command which is evaluated whenever a new image was
           displayed which has different size or data type than the previous
           image. The command will also be evaluated when the image was
           cleared.

     get_panel
           Return the pathName of the panel widget

     get_image
           Return the pathName of the Rtd image widget

     get_canvas
           Return the pathName of the canvas of the main Rtd image widget

     get_pan
           Return the pathName of the pan window

     traceXY
           Define a command which is evaluated when the mouse pointer is
           moved in the main window. The image pointer coordinates x, y
           are passed as parameters.
           traceXY can be used, e.g. to display the wavelength

.SH SEE ALSO 
.nf 
.LP 
RTD documentation, Rtd(n), TopLevelWidget(n)

